﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using WeifenLuo.WinFormsUI.Docking;
using LibBinaryRelation;
using LibBinaryRelation.Controls;
using System.Windows.Forms.Integration;

namespace BinaryRelation
{
    public partial class MainForm : Form
    {

        public MainForm()
        {
            InitializeComponent();
            c.Show(dockPanel1);
            d.Show(dockPanel1);
            c.ChangedItem += new LibBinaryRelation.Controls.DelegateChanged(cChangedItem);
            c.ChangedDock += new LibBinaryRelation.Controls.DelegateChanged(cChangedDock);
            Preamble p = new Preamble();
            p.BorderStyle = BorderStyle.Fixed3D; p.Dock = DockStyle.Fill;
            d.Controls.Clear();
            d.Controls.Add(p);
            this.toolStripStatusLabel1.Text = c.NameItem;
        }

        Display d = new Display();
        Content c = new Content();
        MyColorDialog colorDialog1 = new MyColorDialog();

        void cChangedDock(object sender)
        {
            c.Show(dockPanel1, ((DockContent)sender).ShowHint);
            c.Font = this.Font;
        }

        void cChangedItem(object sender)
        {
            d.Controls.Clear();
            Control c_sender = (Control)sender;

            /*if (value != -1)
            {
                //((Interface1)l[value]).ReleaseElementHost();
                value = -1;
            }

            if (c_sender.Name == "CP")
            {
                value = 3;
                //((Interface1)l[value]).SetElementHost(element_host);
                c_sender = l[3];
            }
            else if (c_sender.Name == "RG")
            {
                value = 0;
                //((Interface1)l[value]).SetElementHost(element_host);
                c_sender = l[0];
            }
            else if (c_sender.Name == "TF")
            {
                value = 2;
                //((Interface1)l[value]).SetElementHost(element_host);
                c_sender = l[2];
            }
            else if (c_sender.Name == "FR")
            {
                value = 1;
                //((Interface1)l[value]).SetElementHost(element_host);
                c_sender = l[1];
            }*/
            d.Controls.Add(c_sender);
            if (c_sender.GetType() == typeof(Preamble) || c_sender.GetType() == typeof(PNGViewer1)) d.AutoScrollMinSize = new Size(0, 0);
            else
            {
                Drawing1.SetAllControlsBackColor(c_sender, d.BackColor);
                d.AutoScrollMinSize = Drawing1.MinimunSizeControl(c_sender.CreateGraphics(), this.Font);
            }
            string name = c.NameItem;
            this.toolStripStatusLabel1.Text = name;
            int index = name.LastIndexOf('\\');
            if (index == -1) d.Text = name;
            else d.Text = name.Substring(index + 1);
        }

        private void toolStripMenuItem6Click(object sender, EventArgs e)
        {
            fontDialog1.Font = this.Font;
            fontDialog1.Color = this.ForeColor;

            if (fontDialog1.ShowDialog() != DialogResult.Cancel) this.Font = fontDialog1.Font;
        }

        private void toolStripMenuItem7_Click(object sender, EventArgs e)
        {
            colorDialog1.Color = d.BackColor;
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                Drawing1.SetAllControlsBackColor(d, colorDialog1.Color, typeof(PNGViewer1), typeof(Preamble));
                c.SetTrieViewBackColor(colorDialog1.Color);
            }
        }

        private void MainFormFontChanged(object sender, EventArgs e)
        {
            this.dockPanel1.Font = d.Font = c.Font = this.Font;
            if (d.Controls.Count != 0)
            {
                if (d.Controls[0].GetType() != typeof(PNGViewer1) && d.Controls[0].GetType() != typeof(Preamble)) d.AutoScrollMinSize = Drawing1.MinimunSizeControl(d.Controls[0].CreateGraphics(), this.Font);
                else d.AutoScrollMinSize = new Size(0, 0);
            }
        }

        private void toolStripMenuItem4Click(object sender, EventArgs e)
        {
            c.Show(dockPanel1, DockState.DockRightAutoHide);
            c.Font = this.Font;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            SetViewer(4, false);
            this.toolStripStatusLabel1.Text = "Binární relace\\Text";
        }

        private void toolStripMenuItem8_Click(object sender, EventArgs e)
        {
            SetViewer(5, true);
            this.toolStripStatusLabel1.Text = "Reprezentace relace\\Text";
        }

        private void toolStripMenuItem9_Click(object sender, EventArgs e)
        {

            SetViewer(5, false);
            this.toolStripStatusLabel1.Text = "Operace mezi relacemi\\Text";
        }

        private void toolStripMenuItem11_Click(object sender, EventArgs e)
        {
            SetViewer(8, true);
            this.toolStripStatusLabel1.Text = "Vlastnosti binárních relací\\Text";
        }

        private void toolStripMenuItem12_Click(object sender, EventArgs e)
        {
            SetViewer(14, false);
            this.toolStripStatusLabel1.Text = "Relace ekvivalence\\Text";
        }

        private void toolStripMenuItem13_Click(object sender, EventArgs e)
        {
            SetViewer(12, false);
            this.toolStripStatusLabel1.Text = "Relace uspořádání\\Text";
        }

        void SetViewer(int page, bool down)
        {
            PNGViewer1 v = c.Viewer1;
            v.SetCurrentItem(page);
            if (down == true) v.SetAutoScrollPositionDown();
            d.Controls.Clear();
            d.Controls.Add(v);
            //Drawing1.SetAllControlsBackColor(v, d.BackColor);
            d.AutoScrollMinSize = new Size(0, 0);
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            helpProvider1.HelpNamespace = Application.StartupPath + "\\Nápověda.chm";
            try
            {
                System.Diagnostics.Process.Start(helpProvider1.HelpNamespace);
            }
            catch
            {
                MessageBox.Show("Nenalezen soubor s nápovědou", "Chybí nápověda", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}
