﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BinaryRelation.Properties;

namespace BinaryRelation
{
    public partial class PNGViewer1 : UserControl
    {
        public PNGViewer1()
        {
            InitializeComponent();
            b = new List<string>();
            currentb = -1;
            currentb_print = -1;
            count_pages = 0;
            SetPrintPreviewDialog();
            embedded_resources = false;
            scale_factor = 1;
        }

        List<string> b;
        int currentb;
        int currentb_print;
        Bitmap bitmap;
        bool embedded_resources;
        int count_pages;
        float scale_factor;

        public void SetPNGs(List<string> paths)
        {
            b.Clear();
            paths.ForEach(item => b.Add(item));
            currentb = 0;
            count_pages = b.Count;
            //SetCurrentB();
            //SetNumberPage();
        }

        public void EmbeddedResources(bool true_or_false)
        {
            this.embedded_resources = true_or_false;
            this.count_pages = 19;
            currentb = 0;
            SetCurrentB();
            SetNumberPage();
        }

        void SetCurrentB()
        {
            if (bitmap != null)
            {
                bitmap.Dispose();
                bitmap = null;
            }
            try
            {

                bitmap = new Bitmap(b[currentb]);
            }
            catch
            {
                bitmap = Resources.F1;
            }

            this.pictureBox1.BackgroundImage = bitmap;
            this.panel1.AutoScrollMinSize = new Size(bitmap.Width, bitmap.Height);
            this.panel1.AutoScrollPosition = new Point(0, 0);
            if (currentb <= 0) this.toolStripButton1.Enabled = false;
            else toolStripButton1.Enabled = true;

            if (currentb >= count_pages - 1) this.toolStripButton2.Enabled = false;
            else this.toolStripButton2.Enabled = true;
        }

        public void SetAutoScrollPositionDown()
        {
            this.panel1.AutoScrollPosition = new Point(0, this.panel1.Width);
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            this.toolStripButton2.Enabled = true;
            currentb--;
            SetCurrentB();
            SetNumberPage();
            if (currentb == 0) this.toolStripButton1.Enabled = false;
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            //this.toolStripButton1.Enabled = true;
            currentb++;
            SetCurrentB();
            SetNumberPage();
            //if (currentb == count_pages - 1) this.toolStripButton2.Enabled = false;
        }

        public bool SetCurrentItem(int number)
        {
            if (number > 0 && number <= count_pages - 1)
            {
                currentb = number;
                SetCurrentB();
                SetNumberPage();
                return true;
            }
            else return false;
        }

        void SetNumberPage()
        {
            this.toolStripLabel1.Text = "strana: " + (currentb + 1) + " / " + count_pages;
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            this.printPreviewDialog1.Document = this.printDocument1;
            this.printPreviewDialog1.ShowDialog();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (this.printDialog1.ShowDialog() == DialogResult.OK)
                this.printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            Graphics g = e.Graphics;
            currentb_print++;
            Bitmap b_print;
            try
            {
                b_print = new Bitmap(b[currentb_print]);
            }
            catch
            {
                b_print = Resources.F;
            }
            g.DrawImage(b_print, e.MarginBounds.Width/2 - b_print.Width/2 + e.MarginBounds.Left, e.MarginBounds.Height/2 - b_print.Height/2 + e.MarginBounds.Top);
            g.Dispose();
            b_print.Dispose();
            b_print = null;
            if (currentb_print < count_pages - 1) e.HasMorePages = true;
            else
            {
                e.HasMorePages = false;
                currentb_print = -1;
            }
        }

        void SetPrintPreviewDialog()
        {
            this.printPreviewDialog1.ShowIcon = false;
            this.printPreviewDialog1.Controls[0].Parent.Text = "Náhled";
            ToolStrip toolstrip = (ToolStrip)this.printPreviewDialog1.Controls[1];

            List<string> names = new List<string>(){"Tisk", "Přiblížení", null, "Jedna strana", "Dvě strany", "Tři strany", 
                                                    "Čtyři strany", "Šest stran", null, "Zavřít", null, "Strana"};

            for (int i = 0; i < toolstrip.Items.Count; i++) if (names[i] != null) toolstrip.Items[i].Text = names[i];
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
         
          Bitmap bit = new Bitmap(bitmap, (int)((float)this.bitmap.Width * 0.9f), (int)((float)this.bitmap.Height * 0.9f));
          //bit.SetResolution(200, 200);
          this.pictureBox1.BackgroundImage = bit;
        }

        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            scale_factor -= 0.1f;
            this.pictureBox1.BackgroundImage = new Bitmap(bitmap, (int)((float)this.bitmap.Width * scale_factor), (int)((float)this.bitmap.Height * scale_factor));
            bitmap.Dispose();
            bitmap = null;
            if (scale_factor == 0.8) this.toolStripButton6.Enabled = false;
        }
    }
}
