﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Threading;
using System.IO;

namespace BinaryRelation
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            try 
            {
                Function();
            }
            catch (FileNotFoundException)
            {
                MessageBox.Show("Aplikace nemohla být spuštěna, protože některou součást aplikace nelze najít\nPotíže pravděpodobně odstraníte opětovnou instalací aplikace", "Součást nelze najít", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        static void Function()
        {
            bool grantedOwnership;

            Mutex singleInstanceMutex = new Mutex(true, "Global\\BinarniRelace100", out grantedOwnership);
            try
            {
                if (grantedOwnership)
                {
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    Application.Run(new MainForm());
                }
            }
            finally
            {
                singleInstanceMutex.Close();
            }
        }
    }
}
