﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LibBinaryRelation.Controls.WPF;
using System.Windows.Forms.Integration;

namespace LibBinaryRelation.Controls
{
    public partial class CartesianProduct : UserControl
    {
        public CartesianProduct()
        {
            InitializeComponent();
            
            List<Brush> l1 = new List<Brush>() 
            {
                Brushes.Red,Brushes.Blue,Brushes.Green,Brushes.Yellow,Brushes.Brown,Brushes.Gray
            };

            List<Brush> l2 = new List<Brush>()
            {
                 Brushes.Red,Brushes.Blue,Brushes.Green,Brushes.Yellow,Brushes.Brown,Brushes.Gray
            };

            l3 = new List<System.Windows.Media.Brush>(); 
            /*{
                System.Windows.Media.Brushes.Red,System.Windows.Media.Brushes.Blue,System.Windows.Media.Brushes.Green,System.Windows.Media.Brushes.Yellow,System.Windows.Media.Brushes.Brown,System.Windows.Media.Brushes.Gray
            };*/

            l4 = new List<System.Windows.Media.Brush>();
            /*{
                System.Windows.Media.Brushes.Red,System.Windows.Media.Brushes.Blue,System.Windows.Media.Brushes.Green,System.Windows.Media.Brushes.Yellow,System.Windows.Media.Brushes.Brown,System.Windows.Media.Brushes.Gray
            };*/

            set1 = new Set("X");
            set2 = new Set("Y");
            //l1.ForEach(brush => set1.AddItemToSet(brush));
            //l2.ForEach(brush => set2.AddItemToSet(brush));
            set1.AddItemToSet(l1[0]); set1.AddItemToSet(l1[1]);
            set2.AddItemToSet(l2[2]); set2.AddItemToSet(l2[3]); set2.AddItemToSet(l2[4]);
            relation = new Relation("R");
            c_set1 = new CreateSet();
            c_set2 = new CreateSet();
            c_set1.SetMaxCountItems = 6;
            c_set2.SetMaxCountItems = 6;
            c_set1.ColorsItem = l1;
            c_set2.ColorsItem = l2;
            signed_item = new List<int>() { 0 };

            SetSet();

            SetBrush(set1, l3);
            SetBrush(set2, l4);
            this.cartesianProduct11.AddItems(l3, l4);
        }

        Set set1;
        Set set2;
        Relation relation;
        List<int> signed_item;
        CreateSet c_set1;
        CreateSet c_set2;
        List<System.Windows.Media.Brush> l3;
        List<System.Windows.Media.Brush> l4;

        private void NameSet1Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width - v_space, p.Height), set1, this.Font);
        }

        private void NameSet2Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width - v_space, p.Height), set2, this.Font);
        }

        private void Relation_Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            if (signed_item[0] != -1)
            {
                Drawing1.SignItemOfRelation(p, g, rect, relation, set1, set2, this.Font, signed_item, Pens.Black);
            }
            Drawing1.DrawRelation(p, g, rect, set1, set2, relation, this.Font);
        }

        public Font GetMaxFont()
        {
            GroupBox l = this.DescriptionRelation;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "\t" + l.Text + "\t", l.Font);
        }

        private void CartesianProductResize(object sender, EventArgs e)
        {
            this.NameSet1.Invalidate();
            this.NameSet2.Invalidate();
            this.Relation.Invalidate();
        }

        private void RightMoveClick(object sender, EventArgs e)
        {
            this.LeftMove.Enabled = true;
            if (this.cartesianProduct11.MoveRight() == false) this.RightMove.Enabled = false;
            signed_item[0] = this.relation.GetNumberOfItemOfRelation(cartesianProduct11.PBox1, cartesianProduct11.PBox2);
            this.Relation.Invalidate();
        }

        private void LeftMoveClick(object sender, EventArgs e)
        {
            this.RightMove.Enabled = true;
            if (this.cartesianProduct11.MoveLeft() == false) this.LeftMove.Enabled = false;
            signed_item[0] = this.relation.GetNumberOfItemOfRelation(cartesianProduct11.PBox1, cartesianProduct11.PBox2);
            this.Relation.Invalidate();
        }

        private void toolStripMenuItem1Click(object sender, EventArgs e)
        {
            c_set1.Font = this.Font;
            Drawing1.SetAllControlsBackColor(c_set1, this.BackColor);
            c_set1.Set = set1;
            DialogResult d = c_set1.ShowDialog();
            if (d == DialogResult.OK)
            {
                set1 = c_set1.Set;
                SetSet();
                this.Relation.Invalidate();
                this.NameSet1.Invalidate();
                SetBrush(set1, l3);
                this.cartesianProduct11.AddItems(l3, l4);
            }
        }

        private void toolStripMenuItem2Click(object sender, EventArgs e)
        {
            c_set2.Font = this.Font;
            Drawing1.SetAllControlsBackColor(c_set2, this.BackColor);
            c_set2.Set = set2;
            DialogResult d = c_set2.ShowDialog();
            if (d == DialogResult.OK)
            {
                set2 = c_set2.Set;
                SetSet();
                this.Relation.Invalidate();
                this.NameSet2.Invalidate();
                SetBrush(set2, l4);
                this.cartesianProduct11.AddItems(l3, l4);
            }
        }

        /*public void SetElementHost(ElementHost element_host)
        {
            element_host.Child = cartesianProduct11;
            this.tableLayoutPanel2.Controls.Add(element_host, 1, 0);
            this.tableLayoutPanel2.SetRowSpan(element_host, 2);
        }

        public void ReleaseElementHost()
        {
            if(this.tableLayoutPanel2.Controls.Count == 3) this.tableLayoutPanel2.Controls.RemoveAt(2);
        }*/

        void SetSet()
        {
            relation.RemoveAllItems();
            for (int i = 0; i < set1.CountItemsInSet(); i++)
            {
                for (int j = 0; j < set2.CountItemsInSet(); j++) relation.AddItemToRelation(i, j, Brushes.Black);
            }
            if (set1.CountItemsInSet() == 0 || set2.CountItemsInSet() == 0)
            {
                signed_item[0] = -1;
                this.LeftMove.Enabled = this.RightMove.Enabled = false;
            }
            else
            {
                signed_item[0] = 0;
                if (set1.CountItemsInSet() == 1 && set2.CountItemsInSet() == 1) this.LeftMove.Enabled = this.RightMove.Enabled = false;
                else { this.LeftMove.Enabled = false; this.RightMove.Enabled = true; }
            }
        }

        void SetBrush(Set set, List<System.Windows.Media.Brush> items)
        {
            items.Clear();
            for (int i = 0; i < set.CountItemsInSet(); i++)
            {
                Brush item = set.GetColorItem(i);
                if (item == Brushes.Red) items.Add(System.Windows.Media.Brushes.Red);
                else if (item == Brushes.Blue) items.Add(System.Windows.Media.Brushes.Blue);
                else if (item == Brushes.Green) items.Add(System.Windows.Media.Brushes.Green);
                else if (item == Brushes.Yellow) items.Add(System.Windows.Media.Brushes.Yellow);
                else if (item == Brushes.Brown) items.Add(System.Windows.Media.Brushes.Brown);
                else if (item == Brushes.Gray) items.Add(System.Windows.Media.Brushes.Gray);
            }
        }
    }
}
