﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Media3D;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using _3DTools;

namespace LibBinaryRelation.Controls.WPF
{
    //public delegate void ReturnActualPairEventHandler(int first_item, int second_item);
    /// <summary>
    /// Interaction logic for CartesianProduct1.xaml
    /// </summary>
    public partial class CartesianProduct1 : UserControl
    {
        public CartesianProduct1()
        {
            try
            {
                InitializeComponent();

                this.SizeChanged += new SizeChangedEventHandler(CartesianProduct1SizeChanged);
                brushes_balls1 = new List<Brush>();

                brushes_balls2 = new List<Brush>();
                base_value = 15;

                Model3DGroup box1 = CreateBox();
                t_box1 = new TranslateTransform3D(0, 4, 0);
                box1.Transform = t_box1;
                ModelVisual3D visual_box1 = new ModelVisual3D();
                visual_box1.Content = box1;
                this.Viewport3D1.Children.Add(visual_box1);

                Model3DGroup box2 = CreateBox();
                t_box2 = new TranslateTransform3D(0, -4, 0);
                box2.Transform = t_box2;
                ModelVisual3D visual_box2 = new ModelVisual3D();
                visual_box2.Content = box2;
                this.Viewport3D1.Children.Add(visual_box2);

                p_box1 = 0;
                p_box2 = 0;
                left_down_position = right_down_position = 0;
            }
            catch
            {
                throw new System.IO.FileNotFoundException("knihovna 3DTools nenalezena");
            }
        }

        TranslateTransform3D t_box1;
        TranslateTransform3D t_box2;
        int p_box1;
        int p_box2;
        double right_down_position;
        double left_down_position;
        List<Brush> brushes_balls1;
        List<Brush> brushes_balls2;
        int base_value;

        void CartesianProduct1SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double max = Math.Max(this.ActualWidth, this.ActualHeight);
            double min = Math.Min(this.ActualWidth, this.ActualHeight);
            double z_coor = max / min * base_value;
            this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, z_coor);
            ////double z_coor1 = (115 / this.ActualHeight) * base_value;
            //double z_coor = 263 / this.ActualWidth * base_value1;
            ///if (z_coor <= z_coor1) base_value = base_value1 + (int)(z_coor1 - z_coor);
            //if (z_coor < z_coor1) this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, z_coor1);
            ///else this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, z_coor);
            ////if (z_coor1 > base_value) this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, z_coor1);//this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, base_value);
            //else
            //{
                //this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, z_coor1);
            //}
        }

        public int PBox1
        {
            get { return p_box1; }
        }

        public int PBox2
        {
            get { return p_box2; }
        }

        public void AddItems(List<Brush> items1, List<Brush> items2)
        {
            brushes_balls1.Clear();
            brushes_balls2.Clear();
            for (int i = this.Viewport3D1.Children.Count - 1; i > 0; i--)
            {
                if(this.Viewport3D1.Children[i].GetType() == typeof(Ball)) this.Viewport3D1.Children.Remove(this.Viewport3D1.Children[i]);
            }
            p_box1 = 0;
            p_box2 = 0;
            left_down_position = 0;
            right_down_position = 0;
            t_box1.OffsetX = 0;
            t_box2.OffsetX = 0;
            if (items1.Count != 0 && items2.Count != 0)
            {
                items1.ForEach(item => brushes_balls1.Add(item));
                items2.ForEach(item => brushes_balls2.Add(item));
                List<Point3D> balls1_positions = GetPositionsOfBalls(brushes_balls1.Count, 0);
                List<Point3D> balls2_positions = GetPositionsOfBalls(brushes_balls2.Count, 1);
                left_down_position = balls2_positions.First().X;
                right_down_position = balls2_positions.Last().X;
                Drawing3D.CreateBalls(Drawing3D.Offset(balls1_positions, 0, 4, 0), brushes_balls1).ForEach(ball => this.Viewport3D1.Children.Add(ball));
                Drawing3D.CreateBalls(Drawing3D.Offset(balls2_positions, 0, -4, 0), brushes_balls2).ForEach(ball => this.Viewport3D1.Children.Add(ball));
            }
        }

        public bool MoveRight()
        {
            if (p_box2 < brushes_balls2.Count - 1)
            {
                p_box2++;
                t_box2.OffsetX += 4;
                if (p_box1 == brushes_balls1.Count - 1 && p_box2 == brushes_balls2.Count - 1) return false;
            }
            else if (p_box1 < brushes_balls1.Count - 1)
            {
                p_box1++;
                p_box2 = 0;
                t_box1.OffsetX += 4;
                t_box2.OffsetX = left_down_position;
            }
            return true;
        }

        public bool MoveLeft()
        {
            if (p_box2 > 0)
            {
                p_box2--;
                t_box2.OffsetX -= 4;
                if (p_box1 == 0 && p_box2 == 0) return false;
            }
            else if (p_box1 > 0)
            {
                p_box1--;
                p_box2 = brushes_balls2.Count - 1;
                t_box1.OffsetX -= 4;
                t_box2.OffsetX = right_down_position;
            }
            return true;
        }

        List<Point3D> GetPositionsOfBalls(int count_items, int box)
        {
            List<Point3D> items = new List<Point3D>();
            float count_items1 = (float)count_items/2;
            int count_items_on_left_side = (int)count_items1;
            int count_items_on_right_side = (int)Math.Ceiling(count_items1);
            for (int i = -count_items_on_left_side; i < count_items_on_right_side; i++) items.Add(new Point3D(i * 4, 0, 0));

            if(box == 0)t_box1.OffsetX = -count_items_on_left_side * 4;
            else t_box2.OffsetX = -count_items_on_left_side * 4;

            //int base_v = (int)((count_items_on_left_side * 4 + (count_items_on_right_side) * 4 + 1) / 9.0f * 15);
            //this.base_value = base_v > this.base_value ? base_v : base_value;
            //this.pc.Position = new Point3D(this.pc.Position.X, this.pc.Position.Y, this.base_value);
            return items;
        }

        Model3DGroup CreateBox()
        {
            Model3DGroup box = new Model3DGroup();
            Brush color_box = Brushes.Khaki;
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(-1, 1, -1), new Point3D(-1, 1, 1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(-1, 1, 1), new Point3D(-1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(-1, -1, -1), new Point3D(-1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(-1, 1, -1), new Point3D(-1, -1, -1), color_box));

            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(1, -1, 1), new Point3D(-1, -1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, 1), new Point3D(-1, -1, -1), new Point3D(1, -1, 1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(1, -1, -1), new Point3D(-1, -1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(-1, -1, -1), new Point3D(1, -1, -1), color_box));

            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, -1), new Point3D(1, -1, -1), new Point3D(1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, -1), new Point3D(1, 1, -1), new Point3D(1, -1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, -1), new Point3D(1, 1, -1), new Point3D(-1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, -1, -1), new Point3D(-1, 1, -1), new Point3D(1, 1, -1), color_box));

            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, 1, 1), new Point3D(1, 1, 1), new Point3D(1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, 1, 1), new Point3D(1, 1, -1), new Point3D(1, 1, 1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, 1, 1), new Point3D(1, 1, -1), new Point3D(-1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(-1, 1, 1), new Point3D(-1, 1, -1),new Point3D(1, 1, -1), color_box));

            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(1, -1, -1), new Point3D(1, 1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(1, 1, -1), new Point3D(1, -1, -1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(1, 1, -1), new Point3D(1, 1, 1), color_box));
            box.Children.Add(Drawing3D.CreateTriangleModel(new Point3D(1, -1, 1), new Point3D(1, 1, 1), new Point3D(1, 1, -1), color_box));
            return box;
        }
    }
}
