﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Media3D;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using _3DTools;

namespace LibBinaryRelation.Controls.WPF
{
    /*<Tools3D:ScreenSpaceLines3D Points="-9,-3,3 -3,-3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,3,3 -3,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,-3,3 -9,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-3,-3,3 -3,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,-3,-3 -3,-3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,3,-3 -3,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,-3,-3 -9,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-3,-3,-3 -3,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,-3,3 -9, -3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-9,3,3 -9, 3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-3,-3,3 -3, -3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="-3,3,3 -3, 3,-3" Color="Black"/>
                
                <Tools3D:ScreenSpaceLines3D Points="3,-3,3 9,-3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,3,3 9,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="9,-3,3 9,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,-3,3 3,3,3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,-3,-3 9,-3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,3,-3 9,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="9,-3,-3 9,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,-3,-3 3,3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="9,-3,3 9, -3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="9,3,3 9, 3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,-3,3 3, -3,-3" Color="Black"/>
                <Tools3D:ScreenSpaceLines3D Points="3,3,3 3, 3,-3" Color="Black"/>*/
    /// <summary>
    /// Interaction logic for Function1.xaml
    /// </summary>
    partial class Function1 : UserControl
    {
        public Function1()
        {
            try
            {
                InitializeComponent();
                this.SizeChanged += new SizeChangedEventHandler(Function1SizeChanged);
                lenght_edge = 6;

                ModelVisual3D v_for_arrows = new ModelVisual3D();
                arrows = new Model3DGroup();
                v_for_arrows.Content = arrows;
                this.Viewport3D1.Children.Add(v_for_arrows);

                lines1 = new ModelVisual3D();
                this.Viewport3D1.Children.Add(lines1);

                first_position_ball = first_position_arrow = 4;//27;

                caption1 = new TextBlock();
                caption2 = new TextBlock();

                arrows2 = new List<List<ArrayList>>();
                for (int i = 0; i < 4; i++) arrows2.Add(new List<ArrayList>());
            }
            catch
            {
                throw new System.IO.FileNotFoundException("knihovna 3DTools nenalezena");
            }
        }

        double lenght_edge;
        Model3DGroup arrows;
        List<List<ArrayList>> arrows2;
        int first_position_arrow;
        int first_position_ball;
        TextBlock caption1;
        TextBlock caption2;
        ModelVisual3D lines1;

        void Function1SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double max = Math.Max(this.ActualWidth, this.ActualHeight);
            double min = Math.Min(this.ActualWidth, this.ActualHeight);
            double z_coor = (max / min * 25) / 1.1;
            double y_coor = (max / min * 7) / 1.1;
            this.pc.Position = new Point3D(this.pc.Position.X, y_coor, z_coor);
        }


        public void RemoveAllArrows()
        {
            for (int i = this.Viewport3D1.Children.Count -1 ; i >= first_position_arrow; i--)
            {
                this.Viewport3D1.Children.RemoveAt(i);
            }

            arrows.Children.Clear();
            arrows2.Clear();
        }

        public void RemoveAllBalls()
        {
            for (int i = first_position_arrow - 1; i >= first_position_ball; i--)
            {
                this.Viewport3D1.Children.RemoveAt(i);
            }
            first_position_arrow = first_position_ball;
        }

        void AddCaptions()
        {
            List<Point3D> points_caption = new List<Point3D>() 
            {
                new Point3D(1.0,7,-3),
                new Point3D(5.0,7,-3),
                new Point3D(5.0,8,-3),
                new Point3D(1.0,8,-3)
            };
            List<Point3D> points_caption1 = Drawing3D.Offset(points_caption, -(lenght_edge + 3), -lenght_edge / 2, lenght_edge / 2);
            List<Point3D> points_caption2 = Drawing3D.Offset(points_caption, 3, -lenght_edge / 2, lenght_edge / 2);

            VisualBrush brush_caption1 = new VisualBrush(caption1);
            VisualBrush brush_caption2 = new VisualBrush(caption2);

           MeshGeometry3D mesh1 = Drawing3D.CreateRectangleWithTextureCoor(points_caption1[0], points_caption1[1], points_caption1[2], points_caption1[3]);
           Material material1 = new DiffuseMaterial(brush_caption1);
           GeometryModel3D model1 = new GeometryModel3D(
               mesh1, material1);

           MeshGeometry3D mesh2 = Drawing3D.CreateRectangleWithTextureCoor(points_caption2[0], points_caption2[1], points_caption2[2], points_caption2[3]);
           Material material2 = new DiffuseMaterial(brush_caption2);
           GeometryModel3D model2 = new GeometryModel3D(
               mesh2, material2);

            Model3DGroup m3dg = new Model3DGroup();
            m3dg.Children.Add(model1); m3dg.Children.Add(model2);

            ModelVisual3D m = new ModelVisual3D();
            m.Content = m3dg;
            this.Viewport3D1.Children.Insert(0, m);

            first_position_arrow++;
            first_position_ball++;
        }

        public void RemoveItem(int number_of_item, int number_of_set)
        {
            for (int i = first_position_arrow - 1; i >= first_position_ball; i--)
            {
                if (this.Viewport3D1.Children[i] is Ball && ((Ball)this.Viewport3D1.Children[i]).NumberOfSet == number_of_set && ((Ball)this.Viewport3D1.Children[i]).NumberOfItem == number_of_item)
                {
                    this.Viewport3D1.Children.RemoveAt(i);
                    first_position_arrow--;
                }
            }
         }

        public void AddNode(Brush color_node, int position_node, int number_set)
        {
            if (position_node >= 0 && position_node <= 4)
            {
                if (IsIn(position_node, number_set)) throw new Exception("na pozici " + position_node + " v mnozine " + number_set + " jiz prvek existuje");
                else
                {
                    Point3D position_ball = GetPositionOfBall(lenght_edge, 1, position_node);
                    Point3D offset_position_ball;
                    if (number_set == 0) offset_position_ball = Drawing3D.Offset(GetPositionOfBall(lenght_edge, 1, position_node), -(lenght_edge + 3), -lenght_edge / 2, lenght_edge / 2);
                    else if (number_set == 1) offset_position_ball = Drawing3D.Offset(GetPositionOfBall(lenght_edge, 1, position_node), 3, -lenght_edge / 2, lenght_edge / 2);
                    else throw new Exception("number_of_set muze nabyvat hodnot 0 nebo 1");

                    Ball ball = new Ball();
                    ball.SetColor = color_node;
                    ball.Offset = offset_position_ball;
                    ball.NumberOfSet = number_set;
                    ball.NumberOfItem = position_node;
                    this.Viewport3D1.Children.Insert(first_position_arrow, ball);
                    first_position_arrow++;
                }
            }
            else throw new Exception("max pozice je 4, min pozice je 0");

        }

        bool IsIn(int number_of_item, int number_of_set)
        {
            for (int i = first_position_arrow - 1; i >= first_position_ball; i--)
            {
                if (((Ball)this.Viewport3D1.Children[i]).NumberOfSet == number_of_set && ((Ball)this.Viewport3D1.Children[i]).NumberOfItem == number_of_item) return true;
            }

            return false;
        }

        public void AddItems(List<Brush> brushes_balls1, List<Brush> brushes_balls2)
        {
            /*if (this.positions_balls1.Count != 0) ClearBallsAndArrows();
            Drawing3D.Offset(GetPositionsOfBalls(lenght_edge, 1, brushes_balls1.Count), -(lenght_edge + 3), -lenght_edge / 2, lenght_edge / 2).ForEach(p_ball => this.positions_balls1.Add(p_ball));
            Drawing3D.Offset(GetPositionsOfBalls(lenght_edge, 1, brushes_balls2.Count), 3, -lenght_edge / 2, lenght_edge / 2).ForEach(p_ball => this.positions_balls2.Add(p_ball));
            Drawing3D.CreateBalls(this.positions_balls1,brushes_balls1).ForEach(ball => this.Viewport3D1.Children.Add(ball));
            Drawing3D.CreateBalls(this.positions_balls2, brushes_balls2).ForEach(ball => this.Viewport3D1.Children.Add(ball));
            //this.arrows2 = new List<ArrayList>[positions_balls1.Count];
            for (int i = 0; i < this.positions_balls1.Count; i++) this.arrows2.Add(new List<ArrayList>());
            this.first_position_arrow += positions_balls1.Count + positions_balls2.Count;
             */ 
        }

        public void AddNamesOfSets(string name_set1, string name_set2)
        {
            this.caption1.Text = name_set1; this.caption2.Text = name_set2;
            AddCaptions();
        }

        public void AddArrow(int node_from_set1, int node_from_set2)
        {
            if (node_from_set1 >= 0 && node_from_set1 <= 4 && node_from_set2 >= 0 && node_from_set2 <= 4)
            {
                Point3D position_ball1 = GetPositionOfBall(lenght_edge, 1, node_from_set1);
                Point3D position_ball2 = GetPositionOfBall(lenght_edge, 1, node_from_set2);
                Point3D offset_position_ball1 = Drawing3D.Offset(GetPositionOfBall(lenght_edge, 1, node_from_set1), -(lenght_edge + 3), -lenght_edge / 2, lenght_edge / 2);
                Point3D offset_position_ball2 = Drawing3D.Offset(GetPositionOfBall(lenght_edge, 1, node_from_set2), 3, -lenght_edge / 2, lenght_edge / 2);

                ArrayList items = new ArrayList();
                Point3D intersection = Drawing3D.GetIntersectionBallAndLine(offset_position_ball2, 1, offset_position_ball1, offset_position_ball2)[1];
                Model3DGroup model3dg = Drawing3D.CreateArrowForLine(offset_position_ball1, intersection, 0.5);
                items.Add(model3dg);
                this.arrows.Children.Add(model3dg);
                ScreenSpaceLines3D line = new ScreenSpaceLines3D();
                line.Color = Colors.Black;
                line.Thickness = 1.0;
                line.Points.Add(offset_position_ball1);
                line.Points.Add(intersection);
                items.Add(line);
                this.Viewport3D1.Children.Add(line);
                items.Add(node_from_set2);
                this.arrows2[node_from_set1].Add(items);
            }
            else throw new Exception("max pozice je 4, min pozice je 0");
           
        }

        public void RemoveArrow(int item_from_set1, int item_from_set2)
        {
            if (item_from_set1 >= 0 && item_from_set1 <= 4 && item_from_set2 >= 0 && item_from_set2 <= 4)
            {
                ArrayList target_item = null;
                int index_of_target_item = -1;
                List<ArrayList> l = this.arrows2[item_from_set1];
                for (int i = 0; i < l.Count; i++)
                {
                    if ((int)l[i][2] == item_from_set2) 
                    { 
                        target_item = l[i];
                        index_of_target_item = i;
                        break; }
                }

                if (target_item != null)
                {
                    Model3DGroup first_item = (Model3DGroup)target_item[0];
                    ScreenSpaceLines3D second_item = (ScreenSpaceLines3D)target_item[1];

                    for (int i = 0; i < arrows.Children.Count; i++)
                    {
                        if (this.arrows.Children[i].Equals(first_item))
                        {
                            this.arrows.Children.RemoveAt(i); break;
                        }
                    }

                    for (int i = this.first_position_arrow; i < this.Viewport3D1.Children.Count; i++)
                    {
                        if (this.Viewport3D1.Children[i].Equals(second_item))
                        {
                            this.Viewport3D1.Children.RemoveAt(i); break;
                        }
                    }

                    this.arrows2[item_from_set1].RemoveAt(index_of_target_item);
                }
            }
            else throw new Exception("max pozice je 4, min pozice je 0");
        }

        public List<int> GetImage(int vzor)
        {
            List<int> images = new List<int>();
            this.arrows2[vzor].ForEach(item => images.Add((int)item[2]));
            return images;
        }

        /*public List<Point3D> GetPositionsOfBalls(double length_edge_cube, double radius_item, int count_items)
        {
            List<Point3D> items = new List<Point3D>();
            if (count_items > 0)
            {
                items.Add(new Point3D(radius_item, radius_item, -radius_item));
                if (count_items > 1)
                {
                    items.Add(new Point3D(radius_item, length_edge_cube - radius_item, -radius_item));
                    if (count_items > 2)
                    {
                        items.Add(new Point3D(length_edge_cube - radius_item, length_edge_cube - radius_item, -length_edge_cube + radius_item));
                        if (count_items > 3) items.Add(new Point3D(length_edge_cube - radius_item, radius_item, -length_edge_cube + radius_item));
                    }
                }
            }
            return items;
        }*/

        public Point3D GetPositionOfBall(double length_edge_cube, double radius_item, int item)
        {
            switch (item)
            {
                case 0: return new Point3D(radius_item, radius_item, -radius_item);
                case 1: return new Point3D(radius_item, length_edge_cube - radius_item, -radius_item);
                case 2: return new Point3D(length_edge_cube - radius_item, length_edge_cube - radius_item, -length_edge_cube + radius_item);
                case 3: return new Point3D(length_edge_cube - radius_item, radius_item, -length_edge_cube + radius_item);
                default: return new Point3D(0, 0, 0);
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            List<Point3D> points = new List<Point3D>();
            points.Add(new Point3D(0, 0, 0));//1
            points.Add(new Point3D(lenght_edge, 0, 0));//2
            points.Add(new Point3D(0, lenght_edge, 0));//3
            points.Add(new Point3D(lenght_edge, lenght_edge, 0));//4
            points.Add(new Point3D(0, lenght_edge, -lenght_edge));//5
            points.Add(new Point3D(lenght_edge, lenght_edge, -lenght_edge));//6
            points.Add(new Point3D(0, 0, -lenght_edge));//7
            points.Add(new Point3D(lenght_edge, 0, -lenght_edge));//8

            List<Point3D> points_cube1 = Drawing3D.Offset(points, -(lenght_edge + 3), -lenght_edge / 2, lenght_edge / 2);
            List<Point3D> points_cube2 = Drawing3D.Offset(points, 3, -lenght_edge / 2, lenght_edge / 2);

            //lines1.Children.Clear();
            Drawing3D.Cube(points_cube1, 1.0, Colors.Black).ForEach(lines => lines1.Children.Add(lines));
            Drawing3D.Cube(points_cube2, 1.0, Colors.Black).ForEach(lines => lines1.Children.Add(lines));
        }
    }
}
