﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Integration;

namespace LibBinaryRelation.Controls
{
    public partial class FunctionAndRelationX : UserControl
    {
        public FunctionAndRelationX()
        {
            InitializeComponent();

            List<Brush> l = new List<Brush>();
            l.Add(Brushes.Blue);
            l.Add(Brushes.Green);
            l.Add(Brushes.Yellow);

            List<System.Windows.Media.Brush> l1 = new List<System.Windows.Media.Brush>()
            {
                System.Windows.Media.Brushes.Blue,
                System.Windows.Media.Brushes.Green,
                System.Windows.Media.Brushes.Yellow,
            };

            for (int i = 0; i < l1.Count; i++)
            {
                this.function11.AddNode(l1[i], i, 0); this.function11.AddNode(l1[i], i, 1);
            }
            this.function11.AddNamesOfSets("Množina X", "Množina X");

            set = new Set("X");
            l.ForEach(item => set.AddItemToSet(item));

            relation = new Relation("R");
            relation.AddItemToRelation(0, 0, Brushes.Black);
            relation.AddItemToRelation(1, 0, Brushes.Black);
            relation.AddItemToRelation(2, 0, Brushes.Black);

            this.imageOfItem1.AddNameFunction("f");
            this.imageOfItem1.AddPotentialImages(l);
            this.imageOfItem1.AddVzor(l[0], 0);
            this.imageOfItem1.ChangedImage += new DelegateChanged(imageOfItem1ChangedImage);
            this.imageOfItem2.AddNameFunction("f");
            this.imageOfItem2.AddPotentialImages(l);
            this.imageOfItem2.AddVzor(l[1], 1);
            this.imageOfItem2.ChangedImage += new DelegateChanged(imageOfItem1ChangedImage);
            this.imageOfItem3.AddNameFunction("f");
            this.imageOfItem3.AddPotentialImages(l);
            this.imageOfItem3.AddVzor(l[2], 2);
            this.imageOfItem3.ChangedImage += new DelegateChanged(imageOfItem1ChangedImage);

            vzor = -1;
        }

        Set set;
        Relation relation;
        int vzor;
        int old_image;
        int new_image;

        /*public void SetElementHost(ElementHost element_host)
        {
            element_host.Child = this.function11;
            this.DescriptionFunction.Controls.Add(element_host);
        }

        public void ReleaseElementHost()
        {
            if (this.DescriptionFunction.Controls.Count == 0) this.DescriptionFunction.Controls.Clear();
        }*/

        private void DescriptionSetPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width - v_space, p.Height), set, this.Font);
        }

        private void Relation1Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, relation, this.Font);
        }

        private void imageOfItem1ChangedImage(object sender)
        {
            SelectorImageOfItem i = (SelectorImageOfItem)sender;
            Point vzor_and_its_new_image = i.GetVzorAndItsCurrentImage;
            int current_image = this.function11.GetImage(vzor_and_its_new_image.X)[0];
            this.function11.RemoveArrow(vzor_and_its_new_image.X, current_image);
            this.function11.AddArrow(vzor_and_its_new_image.X, vzor_and_its_new_image.Y);
            relation.RemoveItemFromRelation(vzor_and_its_new_image.X, current_image);
            relation.AddItemToRelation(vzor_and_its_new_image.X, vzor_and_its_new_image.Y, Brushes.Black);
            this.vzor = vzor_and_its_new_image.X;
            this.old_image = current_image;
            this.new_image = vzor_and_its_new_image.Y;
            Relation1.Invalidate();
            ChangeRelation.Invalidate();
            ChangeFunction.Invalidate();
        }

        private void ChangeRelationPaint(object sender, PaintEventArgs e)
        {
            if (vzor != -1)
            {
                PictureBox p = (PictureBox)sender;
                Graphics g = e.Graphics;
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                RectangleF rect = new Rectangle();
                float width_first_cap = g.MeasureString("Vyjmut prvek ", this.Font).Width;
                float width_second_cap = g.MeasureString("Vložen prvek ", this.Font).Width;
                float width_third_cap = g.MeasureString(" do R", this.Font).Width;
                List<float> size_item = Drawing1.GetSizeOfItemOfRelation(g, this.Font, 1);
                rect.X = (p.Width - (width_second_cap + size_item[0] + width_third_cap)) / 2;
                rect.Y = p.Height / 4 - size_item[1] / 2;
                g.DrawString("Vložen prvek ", this.Font, Brushes.Black, rect.X, rect.Y);
                rect.Y += p.Height / 2;
                g.DrawString("Vyjmut prvek ", this.Font, Brushes.Black, rect.X, rect.Y);
                rect.X += width_second_cap;
                rect.Width = size_item[0];
                rect.Height = size_item[1];
                Drawing1.DrawItemOfRelation(g, rect, set.GetColorItem(this.vzor), set.GetColorItem(this.old_image), size_item[2], size_item[4], size_item[3], this.Font);
                rect.Y -= p.Height / 2;
                Drawing1.DrawItemOfRelation(g, rect, set.GetColorItem(this.vzor), set.GetColorItem(this.new_image), size_item[2], size_item[4], size_item[3], this.Font);
                rect.X += rect.Width;
                g.DrawString(" do R", this.Font, Brushes.Black, rect.X, rect.Y);
                rect.Y += p.Height / 2;
                g.DrawString(" z R", this.Font, Brushes.Black, rect.X, rect.Y);
            }
        }

        private void ChangeFunctionPaint(object sender, PaintEventArgs e)
        {
            if (this.vzor != -1)
            {
                PictureBox p = (PictureBox)sender;
                Graphics g = e.Graphics;
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;

                string text1 = "(Nový obraz prvku)";
                string text2 = "(Předchozí obraz prvku)";

                List<float> size = Drawing1.GetSizeAndParametersOfImageOfItem(g, "f", this.Font);
                float width_text2 = g.MeasureString(text2, this.Font).Width;
                float x = p.Width / 2 - (size[0] + width_text2) / 2;
                float y = p.Height / 4 - size[1] / 2;

                Drawing1.DrawImageOfItem(g, x, y, size, "f", set.GetColorItem(this.vzor), set.GetColorItem(this.new_image), this.Font);
                g.DrawString(text1, this.DescriptionRelation.Font, Brushes.Black, x + size[0], y);

                y += p.Height / 2;
                Drawing1.DrawImageOfItem(g, x, y, size, "f", set.GetColorItem(this.vzor), set.GetColorItem(this.old_image), this.Font);
                g.DrawString(text2, this.Font, Brushes.Black, x + size[0], y);
            }
        }

        public Font GetMaxFont()
        {
            GroupBox l = this.DescriptionRelation;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "M" + "f( M ) = M(Předchozí obraz prvku)" + "M", this.Font);
        }

        private void FunctionAndRelationXResize(object sender, EventArgs e)
        {
            DescriptionSet.Invalidate();
            Relation1.Invalidate();
            ChangeRelation.Invalidate();
            ChangeFunction.Invalidate();
        }

        private void FunctionAndRelationX_Load(object sender, EventArgs e)
        {
            this.function11.AddArrow(0, 0);
            this.function11.AddArrow(1, 0);
            this.function11.AddArrow(2, 0);
        }
    }
}
