﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Media3D;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using _3DTools;

namespace LibBinaryRelation.Controls.WPF
{
    /// <summary>
    /// Interaction logic for Graph1.xaml
    /// </summary>
    public partial class Graph1 : UserControl
    {
        public Graph1()
        {
            try
            {
                InitializeComponent();
                this.SizeChanged += new SizeChangedEventHandler(Graph1SizeChanged);
                ModelVisual3D v_for_arrows = new ModelVisual3D();
                arrows = new Model3DGroup();
                v_for_arrows.Content = arrows;
                this.Viewport3D1.Children.Add(v_for_arrows);

                first_position_arrow = 1;
            }
            catch
            {
                throw new System.IO.FileNotFoundException("knihovna 3DTools nenalezena");
            }
            
        }

        Model3DGroup arrows;
        List<ArrayList>[] arrows2;
        int first_position_arrow;
        List<Point3D> positions_balls1;

        void Graph1SizeChanged(object sender, SizeChangedEventArgs e)
        {
            double max = Math.Max(this.ActualWidth, this.ActualHeight);
            double min = Math.Min(this.ActualWidth, this.ActualHeight);
            double z_coor = max / min * 30;
            double x_coor = max / min * 12;
            this.pc.Position = new Point3D(x_coor, this.pc.Position.Y, z_coor);
        }

        public void AddArrow(int first_node, int second_node, Color color)
        {
            if (positions_balls1 != null && first_node >= 0 && first_node < this.positions_balls1.Count && second_node >= 0 && second_node < this.positions_balls1.Count)
            {
                if (!this.arrows2[first_node].Exists(item => (int)item[2] == second_node))
                {
                    ArrayList items = new ArrayList();
                    if (first_node == second_node)
                    {
                        double x;
                        Point3D target_point = this.positions_balls1[first_node];
                        if (target_point.X < 0) x = -4;
                        else x = 4;
                        Point3D p1 = new Point3D(0, 0, 0);
                        Point3D p2 = new Point3D(x, -3, 0);
                        Point3D p3 = new Point3D(x, 3, 0);
                        Point3D p4 = new Point3D(0, 0, 0);

                        Point3D intersection = Drawing3D.GetIntersectionBallAndLine(p4, 1, p3, p4)[1];
                        Model3DGroup model3dg = Drawing3D.CreateArrowForLine(p3, intersection, 1);

                        ScreenSpaceBezierCurve bc = new ScreenSpaceBezierCurve(p1, p2, p3, intersection, Colors.Black);
                        model3dg.Transform = bc.Transform = new TranslateTransform3D(target_point.X, target_point.Y, target_point.Z);

                        this.arrows.Children.Add(model3dg);
                        this.Viewport3D1.Children.Add(bc);

                        items.Add(model3dg);
                        items.Add(bc);
                        items.Add(second_node);

                        this.arrows2[first_node].Add(items);
                    }
                    else
                    {
                        Point3D intersection = Drawing3D.GetIntersectionBallAndLine(this.positions_balls1[second_node], 1, this.positions_balls1[first_node], this.positions_balls1[second_node])[1];
                        Model3DGroup model3dg = Drawing3D.CreateArrowForLine(this.positions_balls1[first_node], intersection, 1);
                        items.Add(model3dg);
                        this.arrows.Children.Add(model3dg);
                        ScreenSpaceLines3D line = new ScreenSpaceLines3D();
                        line.Color = color;
                        line.Thickness = 1.0;
                        line.Points.Add(this.positions_balls1[first_node]);
                        line.Points.Add(intersection);
                        items.Add(line);
                        this.Viewport3D1.Children.Add(line);
                        items.Add(second_node);
                        this.arrows2[first_node].Add(items);
                    }
                }
            }
            else throw new Exception("hodnota parametru first_node(second_node) nemuze byt vetsi nebo rovna poctu prvku v mnozine nebo mensi jak nula");
        }

        public void RemoveArrow(int first_node, int second_node)
        {
            if (positions_balls1 != null && first_node >= 0 && first_node < this.positions_balls1.Count && second_node >= 0 && second_node < this.positions_balls1.Count)
            {
                ArrayList target_item = null;
                int index_of_target_item = -1;
                List<ArrayList> l = this.arrows2[first_node];
                for (int i = 0; i < l.Count; i++)
                {
                    if ((int)l[i][2] == second_node)
                    {
                        target_item = l[i];
                        index_of_target_item = i;
                        break;
                    }
                }

                if (target_item != null)
                {
                    Model3DGroup first_item = (Model3DGroup)target_item[0];
                    ModelVisual3D second_item = (ModelVisual3D)target_item[1];

                    for (int i = 0; i < arrows.Children.Count; i++)
                    {
                        if (this.arrows.Children[i].Equals(first_item))
                        {
                            this.arrows.Children.RemoveAt(i); break;
                        }
                    }

                    for (int i = this.first_position_arrow; i < this.Viewport3D1.Children.Count; i++)
                    {
                        if (this.Viewport3D1.Children[i].Equals(second_item))
                        {
                            this.Viewport3D1.Children.RemoveAt(i); break;
                        }
                    }

                    this.arrows2[first_node].RemoveAt(index_of_target_item);
                }
            }
            else throw new Exception("hodnota parametru first_node(second_node) nemuze byt vetsi nebo rovna poctu prvku v mnozine nebo mensi jak nula");
        }

        public void AddNodes(List<Brush> colors_nodes)
        {
            arrows.Children.Clear();
            first_position_arrow = 1;
            for (int i = this.Viewport3D1.Children.Count - 1; i > 0; i--)
            {
                if (this.Viewport3D1.Children[i].GetType() == typeof(Ball) || this.Viewport3D1.Children[i].GetType() == typeof(ScreenSpaceLines3D)
                    || this.Viewport3D1.Children[i].GetType() == typeof(ScreenSpaceBezierCurve)) this.Viewport3D1.Children.Remove(this.Viewport3D1.Children[i]);
            }
            this.positions_balls1 = GetPositionsOfBalls(colors_nodes.Count);
            this.first_position_arrow += colors_nodes.Count;
            Drawing3D.CreateBalls(this.positions_balls1, colors_nodes).ForEach(ball => this.Viewport3D1.Children.Add(ball));
            this.arrows2 = new List<ArrayList>[colors_nodes.Count];
            for (int i = 0; i < this.arrows2.Count(); i++) this.arrows2[i] = new List<ArrayList>();
        }

        public void Release()
        {
            List<Visual> l = new List<Visual>();
            TreeHelper(this, l);
        }

        void TreeHelper(Visual v,List<Visual> l)
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(v); i++)
            {
                // Retrieve child visual at specified index value.
                Visual child = (Visual)VisualTreeHelper.GetChild(v, i);
                l.Add(child);
                TreeHelper(child, l);

                // Do processing of the child visual object.

                // Enumerate children of the child visual object.
                //EnumVisual(childVisual);
            }
        }

        List<Point3D> GetPositionsOfBalls(int number_nodes)
        {
            List<Point3D> items = new List<Point3D>();
            if (number_nodes > 0)
            {
                items.Add(new Point3D(-6, -6, 6));
                if (number_nodes > 1)
                {
                    items.Add(new Point3D(6, 6, -6));
                    if (number_nodes > 2)
                    {
                        items.Add(new Point3D(6, -6, 6));
                        if (number_nodes > 3)
                        {
                            items.Add(new Point3D(-6, 6, -6));
                            if (number_nodes > 4)
                            {
                                items.Add(new Point3D(-6, -6, -6));
                                if (number_nodes > 5)
                                {
                                    items.Add(new Point3D(-6, 6, 6));
                                    if (number_nodes > 6)
                                    {
                                        items.Add(new Point3D(6, 6, 6));
                                        if (number_nodes > 7)
                                        {
                                            items.Add(new Point3D(6, -6, -6));
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return items;
        }
    }
}
