﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LibBinaryRelation.Controls
{
    public partial class IntersectionRelation : UserControl
    {
        public IntersectionRelation()
        {
            InitializeComponent();
            set = new Set("X");
            R1 = new Relation("R");
            R2 = new Relation("L");
            R3 = new Relation("K");

            List<string> l = new List<string>();
            l.Add("a");
            l.Add("b");
            l.Add("c");
            l.Add("d");

            l.ForEach(item => set.AddItemToSet(item));

            R1.AddItemToRelation(0, 1,Brushes.Red);
            R1.AddItemToRelation(1, 2,Brushes.Red);
            R1.AddItemToRelation(0, 2, Brushes.Black);
            R1.AddItemToRelation(2, 0, Brushes.Black);
            R1.AddItemToRelation(2, 3, Brushes.Red);

            R2.AddItemToRelation(0, 1, Brushes.Red);
            R2.AddItemToRelation(1, 2, Brushes.Red);
            R2.AddItemToRelation(1, 3, Brushes.Black);
            R2.AddItemToRelation(3, 0, Brushes.Black);
            R2.AddItemToRelation(2, 3, Brushes.Red);

            R3.AddItemToRelation(0, 1, Brushes.Red);
            R3.AddItemToRelation(1, 2, Brushes.Red);
            R3.AddItemToRelation(2, 3, Brushes.Red);

            graph1 = new Graph();
            graph1.Dock = DockStyle.Fill;
            graph1.TabStop = false;
            graph1.SetGrid(3, 3);
            graph1.AddNode("a", 2, 0);
            graph1.AddNode("b", 2, 2);
            graph1.AddNode("c", 0, 2);
            graph1.AddNode("d", 0, 0);
            graph1.AddArrow(0, 1, Brushes.Red);
            graph1.AddArrow(1, 2, Brushes.Red);
            graph1.AddArrow(0, 2, Brushes.Black);
            graph1.AddArrow(2, 0, Brushes.Black);
            graph1.AddArrow(2, 3, Brushes.Red);

            graph2 = new Graph();
            graph2.Dock = DockStyle.Fill;
            graph2.TabStop = false;
            graph2.SetGrid(3, 3);
            graph2.AddNode("a", 2, 0);
            graph2.AddNode("b", 2, 2);
            graph2.AddNode("c", 0, 2);
            graph2.AddNode("d", 0, 0);
            graph2.AddArrow(0, 1, Brushes.Red);
            graph2.AddArrow(1, 2, Brushes.Red);
            graph2.AddArrow(1, 3, Brushes.Black);
            graph2.AddArrow(3, 0, Brushes.Black);
            graph2.AddArrow(2, 3, Brushes.Red);

            graph3 = new Graph();
            graph3.Dock = DockStyle.Fill;
            graph3.TabStop = false;
            graph3.SetGrid(3, 3);
            graph3.AddNode("a", 2, 0);
            graph3.AddNode("b", 2, 2);
            graph3.AddNode("c", 0, 2);
            graph3.AddNode("d", 0, 0);
            graph3.AddArrow(0, 1, Brushes.Red);
            graph3.AddArrow(1, 2, Brushes.Red);
            graph3.AddArrow(2, 3, Brushes.Red);

            matrix1.AddNamesItems(l, l, "R");
            matrix1.PutValueToItem(0, 1, "1", Color.Red);
            matrix1.PutValueToItem(1, 2, "1", Color.Red);
            matrix1.PutValueToItem(0, 2, "1", Color.Black);
            matrix1.PutValueToItem(2, 0, "1", Color.Black);
            matrix1.PutValueToItem(2, 3, "1", Color.Red);

            matrix2.AddNamesItems(l, l, "L");
            matrix2.PutValueToItem(0, 1, "1", Color.Red);
            matrix2.PutValueToItem(1, 2, "1", Color.Red);
            matrix2.PutValueToItem(1, 3, "1", Color.Black);
            matrix2.PutValueToItem(3, 0, "1", Color.Black);
            matrix2.PutValueToItem(2, 3, "1", Color.Red);

            matrix3.AddNamesItems(l, l, "K");
            matrix3.PutValueToItem(0, 1, "1", Color.Red);
            matrix3.PutValueToItem(1, 2, "1", Color.Red);
            matrix3.PutValueToItem(2, 3, "1", Color.Red);

        }

        Set set;
        Relation R1;
        Relation R2;
        Relation R3;
        Graph graph1;
        Graph graph2;
        Graph graph3;

        private void Relation1Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, R1, this.DescriptionGraph3.Font);
        }

        private void Relation2Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, R2, this.DescriptionGraph3.Font);
        }

        private void Relation3Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, R3, this.DescriptionGraph3.Font);
        }

        public override Font Font
        {
            get
            {
                return base.Font;
            }
            set
            {
                base.Font = value;
                /*this.DescriptionRelation1.Font = this.DescriptionRelation2.Font = this.DescriptionRelation3.Font = value;
                this.DescriptionGraph3 .Font = this.DescriptionGraph1.Font = this.DescriptionGraph2.Font = this.DescriptionSet.Font = value;
                this.matrix1.Font = value;
                this.matrix1.Font = this.matrix2.Font = this.matrix3.Font = value;
                MatrixButtonResize();*/
                Relation1.Invalidate();
                Relation2.Invalidate();
                Relation3.Invalidate();
            }
        }

        public Font GetMaxFont()
        {
           GroupBox l = this.DescriptionGraph3;
           return Drawing1.GetFont(l.CreateGraphics(), l.Width, l.Height, "M" + l.Text + "M", this.Font);
        }

        private void IntersectionRelationResize(object sender, EventArgs e)
        {
            this.Relation1.Invalidate();
            this.Relation2.Invalidate();
            this.Relation3.Invalidate();
        }

        private void radioButton1CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                Drawing1.SetAllControlsBackColor(this.matrix1, this.BackColor);
                Drawing1.SetAllControlsBackColor(this.matrix2, this.BackColor);
                Drawing1.SetAllControlsBackColor(this.matrix3, this.BackColor);
                this.DescriptionGraph1.Controls.Remove(this.graph1);
                this.DescriptionGraph1.Controls.Add(this.matrix1);
                this.DescriptionGraph1.Text = "Matice reprezentující relaci R";
                this.DescriptionGraph2.Controls.Remove(this.graph2);
                this.DescriptionGraph2.Controls.Add(this.matrix2);
                this.DescriptionGraph2.Text = "Matice reprezentující relaci L";
                this.DescriptionGraph3.Controls.Remove(this.graph3);
                this.DescriptionGraph3.Controls.Add(this.matrix3);
                this.DescriptionGraph3.Text = "Matice reprezentující relaci K";
            }
        }

        private void radioButton2CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked == true)
            {
                Drawing1.SetAllControlsBackColor(this.graph1, this.BackColor);
                Drawing1.SetAllControlsBackColor(this.graph2, this.BackColor);
                Drawing1.SetAllControlsBackColor(this.graph3, this.BackColor);
                this.DescriptionGraph1.Controls.Remove(this.matrix1);
                this.DescriptionGraph1.Controls.Add(this.graph1);
                this.DescriptionGraph1.Text = "Graf reprezentující relaci R";
                this.DescriptionGraph2.Controls.Remove(this.matrix2);
                this.DescriptionGraph2.Controls.Add(this.graph2);
                this.DescriptionGraph2.Text = "Graf reprezentující relaci L";
                this.DescriptionGraph3.Controls.Remove(this.matrix3);
                this.DescriptionGraph3.Controls.Add(this.graph3);
                this.DescriptionGraph3.Text = "Graf reprezentující relaci K";
            }
        }
    }
}
