﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LibBinaryRelation.Controls
{
    public partial class OrderRelation1 : UserControl
    {
        public OrderRelation1()
        {
            InitializeComponent();

            set = new Set("X");            
            order_relation = new Relation("R");
            coverage_relation = new Relation("L");
            _case = -1;
            Case1();
        }

        Set set;
        Relation order_relation;
        Relation coverage_relation;
        int count_places;
        int _case;

        void Case1()
        {
            if (_case != 0)
            {
                Clear();

                this.DescriptionORelation.Text = "R je antiřetězec na X";

                set.AddItemToSet("1"); set.AddItemToSet("2"); set.AddItemToSet("3");
                set.AddItemToSet("4"); set.AddItemToSet("5"); set.AddItemToSet("6");

                order_relation.AddItemToRelation(0, 0, Brushes.Black);
                order_relation.AddItemToRelation(1, 1, Brushes.Black);
                order_relation.AddItemToRelation(2, 2, Brushes.Black);
                order_relation.AddItemToRelation(3, 3, Brushes.Black);
                order_relation.AddItemToRelation(4, 4, Brushes.Black);
                order_relation.AddItemToRelation(5, 5, Brushes.Black);
              
                SetItems();

                coverage_relation = Computing.CoverageRelation(order_relation, "L");

                this.diagram1.SetGrid(1, 6);
                this.diagram1.AddNode(set.GetNameItem(0), 0, 0, true);
                this.diagram1.AddNode(set.GetNameItem(1), 1, 0, true);
                this.diagram1.AddNode(set.GetNameItem(2), 2, 0, true);
                this.diagram1.AddNode(set.GetNameItem(3), 3, 0, true);
                this.diagram1.AddNode(set.GetNameItem(4), 4, 0, true);
                this.diagram1.AddNode(set.GetNameItem(5), 5, 0, true);

                count_places = 1;
                _case = 0;
                DrawORelation.Invalidate();
                DrawCRelation.Invalidate();
                diagram1.DiagramPaint();
                this.DecsriptionSet.Invalidate();
            }
        }

        void Case2()
        {
            if (_case != 1)
            {
                Clear();

                this.DescriptionORelation.Text = "R je relace \"menší nebo rovno\" na X";

                set.AddItemToSet("1"); set.AddItemToSet("2"); set.AddItemToSet("3");
                set.AddItemToSet("4"); set.AddItemToSet("5"); set.AddItemToSet("6");

                for (int i = 0; i < set.CountItemsInSet(); i++)
                {
                    for (int j = i; j < set.CountItemsInSet(); j++) order_relation.AddItemToRelation(i, j, Brushes.Black);
                }
                
                SetItems();

                coverage_relation = Computing.CoverageRelation(order_relation, "L");
                
                this.diagram1.SetGrid(6, 1);
                this.diagram1.AddNode(set.GetNameItem(5), 0, 0, true);
                this.diagram1.AddNode(set.GetNameItem(4), 0, 1, true);
                this.diagram1.AddNode(set.GetNameItem(3), 0, 2, true);
                this.diagram1.AddNode(set.GetNameItem(2), 0, 3, true);
                this.diagram1.AddNode(set.GetNameItem(1), 0, 4, true);
                this.diagram1.AddNode(set.GetNameItem(0), 0, 5, true);

                this.diagram1.AddArrow("1", "2");
                this.diagram1.AddArrow("2", "3");
                this.diagram1.AddArrow("3", "4");
                this.diagram1.AddArrow("4", "5");
                this.diagram1.AddArrow("5", "6");

                count_places = 1;
                _case = 1;
                DrawORelation.Invalidate();
                DrawCRelation.Invalidate();
                diagram1.DiagramPaint();
                this.DecsriptionSet.Invalidate();
            }
        }

        void Case3()
        {
            if (_case != 2)
            {
                Clear();

                this.DescriptionORelation.Text = "R je relace uspořádání podle dělitelnosti na X";

                set.AddItemToSet("1"); set.AddItemToSet("2"); set.AddItemToSet("3");
                set.AddItemToSet("5"); set.AddItemToSet("6"); set.AddItemToSet("10");
                set.AddItemToSet("15"); set.AddItemToSet("30");

                int item;
                for (int i = 0; i < set.CountItemsInSet(); i++)
                {
                    item = int.Parse(set.GetNameItem(i));
                    for (int j = 0; j < set.CountItemsInSet(); j++) if (int.Parse(set.GetNameItem(j)) % item == 0) order_relation.AddItemToRelation(i, j, Brushes.Black);
                }
                
                SetItems();

                coverage_relation = Computing.CoverageRelation(order_relation, "L");

                this.diagram1.SetGrid(4, 3);
                this.diagram1.AddNode(set.GetNameItem(0), 1, 3, true);
                this.diagram1.AddNode(set.GetNameItem(1), 2, 2, true);
                this.diagram1.AddNode(set.GetNameItem(2), 1, 2, true);
                this.diagram1.AddNode(set.GetNameItem(3), 0, 2, true);
                this.diagram1.AddNode(set.GetNameItem(4), 2, 1, true);
                this.diagram1.AddNode(set.GetNameItem(5), 1, 1, true);
                this.diagram1.AddNode(set.GetNameItem(6), 0, 1, true);
                this.diagram1.AddNode(set.GetNameItem(7), 1, 0, true);

                this.diagram1.AddArrow("1", "3"); this.diagram1.AddArrow("1", "2"); this.diagram1.AddArrow("1", "5");
                this.diagram1.AddArrow("3", "15"); this.diagram1.AddArrow("3", "6");
                this.diagram1.AddArrow("10", "5"); this.diagram1.AddArrow("10", "2"); this.diagram1.AddArrow("10", "30");
                this.diagram1.AddArrow("15", "30"); this.diagram1.AddArrow("30", "6");
                this.diagram1.AddArrow("6", "2"); this.diagram1.AddArrow("5", "15");

                count_places = 2;
                _case = 2;
                DrawORelation.Invalidate();
                DrawCRelation.Invalidate();
                diagram1.DiagramPaint();
                this.DecsriptionSet.Invalidate();
            }
        }

        void Case4()
        {
            if (_case != 3)
            {
                Clear();

                this.DescriptionORelation.Text = "R je relace uspořádání na X";;

                set.AddItemToSet("a"); set.AddItemToSet("b"); set.AddItemToSet("c"); set.AddItemToSet("d");

                order_relation.AddItemToRelation(0, 0, Brushes.Black);
                order_relation.AddItemToRelation(1, 1, Brushes.Black);
                order_relation.AddItemToRelation(2, 0, Brushes.Black);
                order_relation.AddItemToRelation(2, 1, Brushes.Black);
                order_relation.AddItemToRelation(2, 2, Brushes.Black);
                order_relation.AddItemToRelation(3, 0, Brushes.Black);
                order_relation.AddItemToRelation(3, 1, Brushes.Black);
                order_relation.AddItemToRelation(3, 2, Brushes.Black);
                order_relation.AddItemToRelation(3, 3, Brushes.Black);                
                
                SetItems();

                coverage_relation = Computing.CoverageRelation(order_relation, "L");

                this.diagram1.SetGrid(3, 3);
                this.diagram1.AddNode(set.GetNameItem(0), 0, 0, true);
                this.diagram1.AddNode(set.GetNameItem(1), 2, 0, true);
                this.diagram1.AddNode(set.GetNameItem(2), 1, 1, true);
                this.diagram1.AddNode(set.GetNameItem(3), 1, 2, true);

                this.diagram1.AddArrow("d", "c"); this.diagram1.AddArrow("c", "a"); this.diagram1.AddArrow("c", "b");

                count_places = 1;
                _case = 3;
                DrawORelation.Invalidate();
                DrawCRelation.Invalidate();
                diagram1.DiagramPaint();
                this.DecsriptionSet.Invalidate();
            }
        }

        void Case5()
        {
            if (_case != 4)
            {
                Clear();

                this.DescriptionORelation.Text = "R je relace \"být podmnožinou\" na X";

                set.AddItemToSet("{}"); set.AddItemToSet("{1}"); set.AddItemToSet("{2}"); set.AddItemToSet("{3}");
                set.AddItemToSet("{1, 2}"); set.AddItemToSet("{1, 3}"); set.AddItemToSet("{2, 3}");
                set.AddItemToSet("{1, 2, 3}");

                order_relation.AddItemToRelation(0, 1, Brushes.Black); order_relation.AddItemToRelation(0, 2, Brushes.Black);
                order_relation.AddItemToRelation(0, 3, Brushes.Black); order_relation.AddItemToRelation(0, 4, Brushes.Black);
                order_relation.AddItemToRelation(0, 5, Brushes.Black); order_relation.AddItemToRelation(0, 6, Brushes.Black);
                order_relation.AddItemToRelation(0, 7, Brushes.Black); order_relation.AddItemToRelation(0, 0, Brushes.Black);

                order_relation.AddItemToRelation(1, 4, Brushes.Black); order_relation.AddItemToRelation(1, 5, Brushes.Black);
                order_relation.AddItemToRelation(1, 7, Brushes.Black); order_relation.AddItemToRelation(1, 1, Brushes.Black);

                order_relation.AddItemToRelation(2, 4, Brushes.Black); order_relation.AddItemToRelation(2, 6, Brushes.Black);
                order_relation.AddItemToRelation(2, 7, Brushes.Black); order_relation.AddItemToRelation(2, 2, Brushes.Black);

                order_relation.AddItemToRelation(3, 5, Brushes.Black); order_relation.AddItemToRelation(3, 6, Brushes.Black);
                order_relation.AddItemToRelation(3, 7, Brushes.Black); order_relation.AddItemToRelation(3, 3, Brushes.Black);

                order_relation.AddItemToRelation(4, 7, Brushes.Black); order_relation.AddItemToRelation(5, 7, Brushes.Black);
                order_relation.AddItemToRelation(6, 7, Brushes.Black); order_relation.AddItemToRelation(7, 7, Brushes.Black);
                
                SetItems();

                coverage_relation = Computing.CoverageRelation(order_relation, "L");

                this.diagram1.SetGrid(4, 3);
                this.diagram1.AddNode(set.GetNameItem(0), 1, 3, true);
                this.diagram1.AddNode(set.GetNameItem(1), 2, 2, true);
                this.diagram1.AddNode(set.GetNameItem(2), 1, 2, true);
                this.diagram1.AddNode(set.GetNameItem(3), 0, 2, true);
                this.diagram1.AddNode(set.GetNameItem(4), 2, 1, true);
                this.diagram1.AddNode(set.GetNameItem(5), 1, 1, true);
                this.diagram1.AddNode(set.GetNameItem(6), 0, 1, true);
                this.diagram1.AddNode(set.GetNameItem(7), 1, 0, true);

                this.diagram1.AddArrow("{}", "{1}"); this.diagram1.AddArrow("{}", "{2}"); this.diagram1.AddArrow("{}", "{3}");
                this.diagram1.AddArrow("{1}", "{1, 3}"); this.diagram1.AddArrow("{1}", "{1, 2}");
                this.diagram1.AddArrow("{3}", "{1, 3}"); this.diagram1.AddArrow("{3}", "{2, 3}");
                this.diagram1.AddArrow("{2}", "{1, 2}"); this.diagram1.AddArrow("{2}", "{2, 3}");
                this.diagram1.AddArrow("{2, 3}", "{1, 2, 3}"); this.diagram1.AddArrow("{1, 3}", "{1, 2, 3}"); this.diagram1.AddArrow("{1, 2}", "{1, 2, 3}");

                count_places = 9;
                _case = 4;
                DrawORelation.Invalidate();
                DrawCRelation.Invalidate();
                diagram1.DiagramPaint();
                this.DecsriptionSet.Invalidate();
            }
        }

        void Clear()
        {
            order_relation.RemoveAllItems();
            coverage_relation.RemoveAllItems();
            set.RemoveAllItems();
            this.diagram1.Clear();
        }

        void SetItems()
        {
            List<string> max_item = Computing.MaximalItem(order_relation, set);
            List<string> min_item = Computing.MinimalItem(order_relation, set);
            string big_item = Computing.BiggestItem(order_relation, set);
            string smal_item = Computing.SmallestItem(order_relation, set);

            if (big_item != null) this.DescriptionBItem.Text = "Největší: " + big_item;
            else this.DescriptionBItem.Text = "Největší: ";

            if (smal_item != null) this.DescriptionSItem.Text = "Nejmenší: " + smal_item;
            else this.DescriptionSItem.Text = "Nejmenší: ";

            this.DescriptionMaxItem.Text = "Maximální: ";

            for (int i = 0; i < max_item.Count - 1; i++)
            {
                this.DescriptionMaxItem.Text += max_item[i] + ", ";
            }

            this.DescriptionMaxItem.Text += max_item[max_item.Count - 1];

            this.DescriptionMinItem.Text = "Minimální: ";

            for (int i = 0; i < min_item.Count - 1; i++)
            {
                this.DescriptionMinItem.Text += min_item[i] + ", ";
            }

            this.DescriptionMinItem.Text += min_item[min_item.Count - 1];
        }

        private void DrawORelationPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, order_relation, p.Font);
        }

        private void DrawCRelationPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, coverage_relation, p.Font);
        }

        public Font GetMaxFont()
        {
            Panel l = this.DecsriptionSet;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "\t" + "Množina X = { 1 , 2 , 3 , 5 , 6 , 10 , 15 , 30 } (množina všech dělitelů čísla 30) " + "\t", l.Font);
        }

        private void DecsriptionSetPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width, p.Height), set, this.Font);
        }

        private void DecsriptionSetResize(object sender, EventArgs e)
        {
            this.DecsriptionSet.Invalidate();
            this.DrawCRelation.Invalidate();
            this.DrawORelation.Invalidate();
        }

        private void radioButton1CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true) Case1();
        }

        private void radioButton2CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked == true) Case2();
        }

        private void radioButton3CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked == true) Case3();
        }

        private void radioButton4CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked == true) Case4();
        }

        private void radioButton5CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked == true) Case5();
        }

    }
}
