﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Text;

namespace LibBinaryRelation.Controls
{
    public partial class ReflexiveRelation : UserControl
    {
        public ReflexiveRelation()
        {
            InitializeComponent();

            List<string> items = new List<string>(){"a","b","c","d"};
            set = new Set("X");
            relation = new Relation("R");

            items.ForEach(item => set.AddItemToSet(item));
           
            relation.AddItemToRelation(0, 0, Brushes.Red);
            relation.AddItemToRelation(1, 0, Brushes.Gray);
            relation.AddItemToRelation(1, 1, Brushes.Green);
            relation.AddItemToRelation(2, 0, Brushes.Gray);
            relation.AddItemToRelation(2, 2, Brushes.Brown);
            relation.AddItemToRelation(3, 2, Brushes.Gray);
            relation.AddItemToRelation(3, 3, Brushes.Blue);
            relation.AddItemToRelation(0, 2, Brushes.Gray);

            graph1.SetGrid(3, 3);
            graph1.AddNode("a", 2, 0);
            graph1.AddNode("b", 2, 2);
            graph1.AddNode("c", 0, 2);
            graph1.AddNode("d", 0, 0);
            this.graph1.AddArrow(0, 0, Brushes.Red);
            this.graph1.AddArrow(1, 0, Brushes.Gray);
            this.graph1.AddArrow(1, 1, Brushes.Green);
            this.graph1.AddArrow(2, 0, Brushes.Gray);
            this.graph1.AddArrow(2, 2, Brushes.Brown);
            this.graph1.AddArrow(3, 2, Brushes.Gray);
            this.graph1.AddArrow(3, 3, Brushes.Blue);
            this.graph1.AddArrow(0, 2, Brushes.Gray);

            this.matrix1.AddNamesItems(items, items, "R");

            for (int i = 0; i < items.Count; i++)
            {
                for (int j = 0; j < items.Count; j++) this.matrix1.PutValueToItem(i, j, "0", Color.Gray);
            }

            this.matrix1.PutValueToItem(0, 0, "1", Color.Red);
            this.matrix1.PutValueToItem(1, 0, "1", Color.Gray);
            this.matrix1.PutValueToItem(1, 1, "1", Color.Green);
            this.matrix1.PutValueToItem(2, 0, "1", Color.Gray);
            this.matrix1.PutValueToItem(2, 2, "1", Color.Brown);
            this.matrix1.PutValueToItem(3, 2, "1", Color.Gray);
            this.matrix1.PutValueToItem(3, 3, "1", Color.Blue);
            this.matrix1.PutValueToItem(0, 2, "1", Color.Gray);
            
            this.graph1.SetWidthArrow(0, 0, 2);
            this.Itema.BorderStyle = BorderStyle.FixedSingle;
            this.Itema.BackColor = Color.Beige;
            this.matrix1.SignOrUnsignItem(0, 0, true);

            actual_item = 0;

            signed_item = new List<int>() { 0 };
        }

        Relation relation;
        Set set;
        int actual_item;
        List<int> signed_item;

        private void DrawRelationPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            g.TextRenderingHint =  TextRenderingHint.AntiAlias;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.SignItemOfRelation(p, g, rect, relation, set, set, this.Font, signed_item, Pens.Black);
            Drawing1.DrawRelation(p, g, rect, set, set, relation, this.Font);
        }

        public Font GetMaxFont()
        {
            GroupBox l = this.CaptionRelation;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "\t" + l.Text + "\t", this.Font);
        }

        private void RightMoveClick(object sender, EventArgs e)
        {
            if (actual_item <= 3) actual_item++;
            SetMagnifyingglass();
        }

        private void LeftMoveClick(object sender, EventArgs e)
        {
            if (actual_item >= 0) actual_item--;
            SetMagnifyingglass();
        }

        void SetMagnifyingglass()
        {
            switch (actual_item)
            {

                case 0:
                    {
                        if (signed_item[0] == 2) 
                        {
                            this.graph1.SetWidthArrow(1, 1, 1); this.matrix1.SignOrUnsignItem(1, 1, false);
                            this.Itemb.BorderStyle = BorderStyle.None;
                        }
                        this.graph1.SetWidthArrow(0, 0, 2);
                        this.matrix1.SignOrUnsignItem(0, 0, true);
                        this.Itema.BorderStyle = BorderStyle.FixedSingle;
                        signed_item[0] = 0;
                        this.DrawRelation.Invalidate();
                        this.LeftMove.Enabled = false; 
                        break;
                    }
                case 1:
                    {
                        if (signed_item[0] == 0) 
                        { 
                            this.graph1.SetWidthArrow(0, 0, 1); this.matrix1.SignOrUnsignItem(0, 0, false);
                            this.Itema.BorderStyle = BorderStyle.None;
                        }
                        else if (signed_item[0] == 4) 
                        { 
                            this.graph1.SetWidthArrow(2, 2, 1); this.matrix1.SignOrUnsignItem(2, 2, false);
                            this.Itemc.BorderStyle = BorderStyle.None;
                        }
                        this.graph1.SetWidthArrow(1, 1, 2);
                        this.matrix1.SignOrUnsignItem(1, 1, true);
                        this.Itemb.BorderStyle = BorderStyle.FixedSingle;
                        signed_item[0] = 2;
                        this.LeftMove.Enabled = true;
                        this.DrawRelation.Invalidate();
                        break;
                    }
                case 2:
                    {
                        if (signed_item[0] == 2) 
                        { 
                            this.graph1.SetWidthArrow(1, 1, 1); this.matrix1.SignOrUnsignItem(1, 1, false);
                            this.Itemb.BorderStyle = BorderStyle.None;
                        }
                        else if (signed_item[0] == 6) 
                        { 
                            this.graph1.SetWidthArrow(3, 3, 1); this.matrix1.SignOrUnsignItem(3, 3, false);
                            this.Itemd.BorderStyle = BorderStyle.None;
                        }
                        this.graph1.SetWidthArrow(2, 2, 2);
                        this.matrix1.SignOrUnsignItem(2, 2, true);
                        this.Itemc.BorderStyle = BorderStyle.FixedSingle;
                        signed_item[0] = 4;
                        this.RightMove.Enabled = true;
                        this.DrawRelation.Invalidate();
                        break;
                    }
                case 3:
                    {
                        if (signed_item[0] == 4) 
                        { 
                            this.graph1.SetWidthArrow(2, 2, 1); this.matrix1.SignOrUnsignItem(2, 2, false);
                            this.Itemc.BorderStyle = BorderStyle.None;
                        }
                        this.graph1.SetWidthArrow(3, 3, 2);
                        this.matrix1.SignOrUnsignItem(3, 3, true);
                        this.Itemd.BorderStyle = BorderStyle.FixedSingle;
                        signed_item[0] = 6;
                        this.DrawRelation.Invalidate();
                        this.RightMove.Enabled = false;
                        break;
                    }
            }
        }

        private void DrawRelation_Resize(object sender, EventArgs e)
        {
            this.DrawRelation.Invalidate();
        }
    }
}
