﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Integration;

namespace LibBinaryRelation.Controls
{
    public partial class RepreRelationGraphX : UserControl
    {
        public RepreRelationGraphX()
        {
            InitializeComponent();
            //this.elementHost1 = element_host;
            //this.tableLayoutPanel2.Controls.Add(elementHost1, 0, 0);
            //this.tableLayoutPanel2.SetRowSpan(this.elementHost1, 2);

            l1 = new List<System.Windows.Media.Brush>()
            {
                System.Windows.Media.Brushes.Blue,
                System.Windows.Media.Brushes.Green,
                System.Windows.Media.Brushes.Aqua,
                System.Windows.Media.Brushes.Gray,
                System.Windows.Media.Brushes.Yellow,
                System.Windows.Media.Brushes.Red,
                System.Windows.Media.Brushes.Brown,
                System.Windows.Media.Brushes.Orange
            };
            this.graph11.AddNodes(l1);

            set = new Set("X");
            l = new List<Brush>();
            l.Add(Brushes.Blue);
            l.Add(Brushes.Green);
            l.Add(Brushes.Aqua);
            l.Add(Brushes.Gray);
            l.Add(Brushes.Yellow);
            l.Add(Brushes.Red);
            l.Add(Brushes.Brown);
            l.Add(Brushes.Orange);
            l.ForEach(item => { set.AddItemToSet(item); });
            selectorColor1.AddItem(l);
            selectorColor2.AddItem(l);

            relation = new Relation("R");
            c_s = new CreateSet();
            c_s.ColorsItem = l;
            c_s.SetMaxCountItems = 8;
            SetButtons();
        }

        Set set;
        Relation relation;
        List<Brush> l;
        List<System.Windows.Media.Brush> l1;
        CreateSet c_s;

        public Font GetMaxFont()
        {
            GroupBox l = this.Caption3;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "\t" + l.Text + "\t", this.Font);
        }

        private void RelationPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, relation, this.Font);
        }

        private void AddArrowClick(object sender, EventArgs e)
        {
            int first_node = selectorColor1.GetCurrentItem;
            int second_node = selectorColor2.GetCurrentItem;

            if (first_node != -1)
            {
                if (relation.AddItemToRelation(first_node, second_node, Brushes.Black) == false) { this.selectorColor1.Signal(); this.selectorColor2.Signal(); }
                else
                {
                    this.graph11.AddArrow(first_node, second_node, System.Windows.Media.Colors.Black);
                    Relation.Invalidate();
                }
            }
            SetButtons();
        }

        private void RemoveArrowClick(object sender, EventArgs e)
        {
            int first_node = selectorColor1.GetCurrentItem;
            int second_node = selectorColor2.GetCurrentItem;

            if (first_node != -1)
            {
                if (relation.RemoveItemFromRelation(first_node, second_node) == false) { this.selectorColor1.Signal(); this.selectorColor2.Signal(); }
                else
                {
                    this.graph11.RemoveArrow(first_node, second_node);
                    Relation.Invalidate();
                }
            }
            SetButtons();
        }

        void SetButtons()
        {
            bool h;
            if (relation.CountItemsInRelation() == 0) h = false;
            else h = true;
            this.RemoveArrow.Enabled = h;

            if (relation.CountItemsInRelation() >= set.CountItemsInSet() * set.CountItemsInSet()) this.AddArrow.Enabled = false;
            else this.AddArrow.Enabled = true;
        }

        private void NameSetPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width - v_space, p.Height), set, this.Font);
        }

        private void RepreRelationGraphXResize(object sender, EventArgs e)
        {
            this.NameSet.Invalidate();
            this.Relation.Invalidate();
        }

        private void toolStripMenuItem1Click(object sender, EventArgs e)
        {
            c_s.Font = this.Font;
            Drawing1.SetAllControlsBackColor(c_s, this.BackColor);
            c_s.Set = set;
            DialogResult d = c_s.ShowDialog();
            if (d == DialogResult.OK)
            {
                set = c_s.Set;
                relation.RemoveAllItems();
                SetButtons();
                this.Relation.Invalidate();
                this.NameSet.Invalidate();
                l.Clear();
                l1.Clear();
                for (int i = 0; i < set.CountItemsInSet(); i++) l.Add(set.GetColorItem(i));
                selectorColor1.AddItem(l); selectorColor2.AddItem(l);
                SetBrush();
                this.graph11.AddNodes(l1);
                if (l1.Count == 0)
                {
                    this.tableLayoutPanel3.Enabled = false;
                }
                else this.tableLayoutPanel3.Enabled = true;
            }
        }

        /*public void SetElementHost(ElementHost element_host)
        {
            element_host.Child = graph11;
            this.tableLayoutPanel2.Controls.Add(element_host, 0, 0);
            this.tableLayoutPanel2.SetRowSpan(element_host, 2);
        }

        public void ReleaseElementHost()
        {
            if (this.tableLayoutPanel2.Controls.Count == 2) this.tableLayoutPanel2.Controls.RemoveAt(1);
        }*/

        void SetBrush()
        {
            l.ForEach(item =>
            {
                if (item == Brushes.Blue) l1.Add(System.Windows.Media.Brushes.Blue);
                else if (item == Brushes.Green) l1.Add(System.Windows.Media.Brushes.Green);
                else if (item == Brushes.Aqua) l1.Add(System.Windows.Media.Brushes.Aqua);
                else if (item == Brushes.Gray) l1.Add(System.Windows.Media.Brushes.Gray);
                else if (item == Brushes.Yellow) l1.Add(System.Windows.Media.Brushes.Yellow);
                else if (item == Brushes.Red) l1.Add(System.Windows.Media.Brushes.Red);
                else if (item == Brushes.Brown) l1.Add(System.Windows.Media.Brushes.Brown);
                else if (item == Brushes.Orange) l1.Add(System.Windows.Media.Brushes.Orange);
            });
        }
    }
}

