﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LibBinaryRelation.Controls
{
    public partial class RepreRelationMatrix : UserControl
    {
        public RepreRelationMatrix()
        {
            InitializeComponent();
            row = 2;
            column = 2;
            set = new Set("X");
            set.AddItemToSet("a"); set.AddItemToSet("b"); set.AddItemToSet("c"); set.AddItemToSet("d"); set.AddItemToSet("e");
            R = new Relation("R");
            this.matrix1.AddNamesItems(set.GetNamesItemsOnSet(), set.GetNamesItemsOnSet(),"K");
            this.matrix1.SignOrUnsignItem(row, column, true);
        }

        int row;
        int column;
        Set set;
        Relation R;

        private void button3_click(object sender, EventArgs e)
        {
            this.matrix1.SignOrUnsignItem(row, column, false);
            if (column < set.CountItemsInSet() - 1) column++;
            this.matrix1.SignOrUnsignItem(row, column, true);
        }

        private void button2_click(object sender, EventArgs e)
        {
            this.matrix1.SignOrUnsignItem(row, column, false);
            if (column > 0) column--;
            this.matrix1.SignOrUnsignItem(row, column, true);
        }

        private void button1_click(object sender, EventArgs e)
        {
            this.matrix1.SignOrUnsignItem(row, column, false);
            if (row > 0) row--;
            this.matrix1.SignOrUnsignItem(row, column, true);
        }

        private void button4_click(object sender, EventArgs e)
        {
            this.matrix1.SignOrUnsignItem(row, column, false);
            if (row < set.CountItemsInSet() - 1) row++;
            this.matrix1.SignOrUnsignItem(row, column, true);
        }

        private void button5_click(object sender, EventArgs e)
        {
            this.matrix1.PutValueToItem(row, column, "0", Color.Black);
            R.RemoveItemFromRelation(row, column);
            panel1.Invalidate();
        }

        private void button6_click(object sender, EventArgs e)
        {
            this.matrix1.PutValueToItem(row, column, "1", Color.Black);
            R.AddItemToRelation(row, column,Brushes.Black);
            panel1.Invalidate();
        }

        private void panel1_paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            g.TextRenderingHint = TextRenderingHint.AntiAlias;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, R, this.Font);
        }

        public Font GetMaxFont()
        {
            GroupBox l = this.groupBox1;
            Graphics g = l.CreateGraphics();
            return Drawing1.GetFont(g, l.Width, l.Height, "\t" + l.Text + "\t", l.Font);
        }

        private void panel1Resize(object sender, EventArgs e)
        {
            this.panel1.Invalidate();
        }
    }
}
