﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LibBinaryRelation.Controls
{
    partial class SelectorImageOfItem : UserControl
    {
        public SelectorImageOfItem()
        {
            InitializeComponent();
            vzor = Brushes.Transparent;
            number_of_item = -1;

            this.selectorItem1.ChangedItem += new DelegateChanged(selectorItem1ChangedItem);
        }

        Brush vzor;
        string name_function;
        int number_of_item;

        public event DelegateChanged ChangedImage;


        private void selectorItem1ChangedItem(object sender)
        {
            SelectorItem s = (SelectorItem)sender;
            if (ChangedImage != null) ChangedImage(this);
        }

        public void AddPotentialImages(List<Brush> images)
        {
            this.selectorItem1.AddItem(images);
        }

        public Point GetVzorAndItsCurrentImage
        {
            get { return new Point(number_of_item , this.selectorItem1.GetCurrentItem); }
        }

        public void AddVzor(Brush vzor, int number_of_item)
        {
            this.vzor = (Brush)vzor.Clone();
            this.number_of_item = number_of_item;
        }

        public void AddNameFunction(string name)
        {
            this.name_function = name;
        }

        private void SurfacePaint(object sender, PaintEventArgs e)
        {
            PictureBox p = (PictureBox)sender;
            Graphics g = e.Graphics;
            g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            SizeF size_name_function = g.MeasureString(name_function, this.Font);
            float width_round_bracket = g.MeasureString("(", this.Font).Width;
            float width_item = g.MeasureString(" \0 ", this.Font).Width;
            float width_e = g.MeasureString("=", this.Font).Width;
            this.selectorItem1.Width = (int)width_item + p.Height;
            this.selectorItem1.Height = p.Height;
            this.selectorItem1.SetWidthButtonsInPercents((p.Height/2 * 100) / this.selectorItem1.Width);
            SizeF size_text = new SizeF(size_name_function.Width + 2 * width_round_bracket + width_item + this.selectorItem1.Width + width_e, size_name_function.Height);
            float move_x = (p.Width - size_text.Width) / 2;
            RectangleF rect = new RectangleF(move_x, 0, 0, p.Height);
            StringFormat s = new StringFormat();
            s.LineAlignment = StringAlignment.Center;
            rect.Width = size_name_function.Width;
            g.DrawString(name_function, this.Font, Brushes.Black, rect,s);
            rect.X += size_name_function.Width;
            rect.Width = width_round_bracket;
            g.DrawString("(", this.Font, Brushes.Black, rect, s);
            rect.X += width_round_bracket;
            rect.Width = width_item;
            float average_of_item = Drawing1.GetAverageOfItem(this.Font);
            Drawing1.DrawItemOfSet(g, vzor, average_of_item, rect.X + rect.Width/2 - average_of_item/2, rect.Height / 2 - average_of_item / 2);
            rect.X += width_item;
            rect.Width = width_round_bracket;
            g.DrawString(")", this.Font, Brushes.Black, rect, s);
            rect.X += width_round_bracket;
            rect.Width = width_e;
            g.DrawString("=", this.Font, Brushes.Black, rect, s);
            rect.X += width_e;
            this.selectorItem1.Location = new Point((int)rect.X, 0);
        }

        private void SurfaceResize(object sender, EventArgs e)
        {
            Surface.Invalidate();
        }
    }
}
