﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LibBinaryRelation
{
    partial class CreateRelation : Form
    {
        public CreateRelation()
        {
            InitializeComponent();
            set = new Set("X");
            relation = new Relation("R");
            //random = new Random();
            height = -1;
        }

        Set set;
        Relation relation;
        //Random random;
        int height;

        public Set Set
        {
            set { set = value; }
        }

        public Relation Relation1
        {
            get { return relation; }
            set { relation = value.Clone(); }
        }

        public bool OrderRelation
        {
            set { this.CreateR.Enabled = this.CreateS.Enabled = value; }
            get { return this.CreateR.Enabled; }
        }

        public bool EquivalenceRelation
        {
            set { this.CreateER.Enabled = value; }
            get { return this.CreateER.Enabled; }
        }

        private void DrawRPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics g = e.Graphics;
            g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
            int v_space = (int)(p.Width * 0.05f);
            Rectangle rect = new Rectangle(v_space, (int)(p.Height * 0.1f), p.Width - 2 * v_space, p.Height);
            Drawing1.DrawRelation(p, g, rect, set, set, relation, this.Font);
        }

        private void CreateRelationShown(object sender, EventArgs e)
        {
            List<string> names_items = new List<string>();
            this.DescriptionR.Text = "Množina " + set.NameSet + ", relace " + relation.NameRelation;
            this.CreateR.Text = "Vytvoř náhodnou relaci uspořádání " + relation.NameRelation;
            this.CreateER.Text = "Vytvoř náhodnou relaci ekvivalence " + relation.NameRelation;
            for (int i = 0; i < set.CountItemsInSet(); i++)
            {
                names_items.Add(set.GetNameItem(i));
            }

            this.selectorPair1.AddItems(names_items, names_items);

            if (height == -1)
            {
                height = this.Height;
                this.MinimumSize = new Size(height, height);
                this.Size = new Size(height, height);
            }
            //this.AutoSize = false;
            this.AutoSizeMode = AutoSizeMode.GrowOnly;
            SetButtons();

            if (set.CountItemsInSet() == 0) this.groupBox1.Enabled = this.groupBox2.Enabled = false;
            else this.groupBox1.Enabled = this.groupBox2.Enabled = true;
        }

        void SetButtons()
        {
            bool h;
            if (relation.CountItemsInRelation() == 0) h = false;
            else h = true;
            this.RemoveItem.Enabled = this.Remove.Enabled = h;

            if (relation.CountItemsInRelation() >= set.CountItemsInSet() * set.CountItemsInSet()) this.AddItem.Enabled = false;
            else this.AddItem.Enabled = true;
        }

        private void AddItemClick(object sender, EventArgs e)
        {
            Point current_items = this.selectorPair1.GetCurrentItems;
            if (current_items.X != -1 && relation.GetNumberOfItemOfRelation(current_items.X, current_items.Y) == -1) { relation.AddItemToRelation(current_items.X, current_items.Y, Brushes.Black); SetButtons(); }
            else this.selectorPair1.Signal();
            this.DrawR.Invalidate();
        }

        private void RemoveItemClick(object sender, EventArgs e)
        {
            Point current_items = this.selectorPair1.GetCurrentItems;
            if (relation.GetNumberOfItemOfRelation(current_items.X, current_items.Y) == -1) this.selectorPair1.Signal();
            else relation.RemoveItemFromRelation(current_items.X, current_items.Y);
            SetButtons();
            this.DrawR.Invalidate();
        }

        private void RemoveClick(object sender, EventArgs e)
        {
            relation.RemoveAllItems();
            SetButtons();
            this.DrawR.Invalidate();
        }

        private void OKClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void StornoClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CreateNSClick(object sender, EventArgs e)
        {
            relation.RemoveAllItems();
            for (int i = 0; i < set.CountItemsInSet(); i++) relation.AddItemToRelation(i, i, Brushes.Black);
            SetButtons();
            this.DrawR.Invalidate();
        }

        private void CreateSClick(object sender, EventArgs e)
        {
            relation.RemoveAllItems();
            for (int i = 0; i < set.CountItemsInSet(); i++) for (int j = i; j < set.CountItemsInSet(); j++) relation.AddItemToRelation(i, j, Brushes.Black);
            SetButtons();
            this.DrawR.Invalidate();
        }

        private void CreateRClick(object sender, EventArgs e)
        {
            relation = Computing.CreateRandomOrderRelation(set, relation.NameRelation);
            SetButtons();
            this.DrawR.Invalidate();
        }

        /*public Relation CreateRandomOrderRelation(Set set, string name_relation)
        {
            Relation r = new Relation(name_relation);
            r = Computing.ReflexiveCRelation(r, set, name_relation);
            Relation help_r = Computing.ReflexiveCRelation(r, set, name_relation);
            int count_items_in_set = set.CountItemsInSet();
            int max_items = ((count_items_in_set * count_items_in_set) - count_items_in_set) / 2;
            int random_max_items = random.Next(max_items + 1);
            int item1, item2;
            for (int i = 0; i < random_max_items; i++)
            {
                item1 = random.Next(count_items_in_set);
                item2 = random.Next(count_items_in_set);
                if (r.GetNumberOfItemOfRelation(item1, item2) == -1)
                {
                    if (r.GetNumberOfItemOfRelation(item2, item1) == -1)
                    {
                        help_r.AddItemToRelation(item1, item2,Brushes.Black);
                        List<int> items_item2 = help_r.GetItemsInRelationWith(item2, 0);
                        List<int> items_item1 = help_r.GetItemsInRelationWith(item1, 1);
                        items_item2.ForEach(item => help_r.AddItemToRelation(item1, item,Brushes.Black));
                        items_item1.ForEach(item => help_r.AddItemToRelation(item, item2,Brushes.Black));
                        if (Computing.IsAntiSymmetry(help_r) && Computing.IsTransitive(help_r)) r = help_r.Clone();
                    }
                }
            }
            return r;
        }*/

        private void DrawSetPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width, p.Height), set, this.Font);
        }

        private void CreateRelationFontChanged(object sender, EventArgs e)
        {
            this.AutoSize = true;
            this.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            height = -1;
        }

        private void CreateERClick(object sender, EventArgs e)
        {
            relation = Computing.CreateRandomEquivalenceRelation(set, relation.NameRelation);
            SetButtons();
            this.DrawR.Invalidate();
        }
    }
}
