﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LibBinaryRelation.Controls;

namespace LibBinaryRelation
{
    partial class CreateSet : Form
    {
        public CreateSet()
        {
            InitializeComponent();
            Item = new TextBox();
            selectorItem1 = new SelectorItem();
 
            Item.BorderStyle = BorderStyle.FixedSingle;
            Item.MaxLength = 2;
            Item.Name = "Item";
            Item.TabIndex = 0;
            Item.Anchor = AnchorStyles.Left;
            Item.BackColor = this.BackColor;
            Item.Size = new Size(70, 20); Item.TextChanged += new EventHandler(Item_TextChanged);
            this.tableLayoutPanel2.Controls.Add(this.Item, 1, 0);
 
 
            this.selectorItem1.AutoSize = true;
            this.selectorItem1.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
            this.selectorItem1.BorderStyle = BorderStyle.Fixed3D;
            this.selectorItem1.Margin = new Padding(0);
            this.selectorItem1.BackColor = System.Drawing.SystemColors.Control;
            this.selectorItem1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.selectorItem1.DrawStringOrColor = LibBinaryRelation.Controls.DrawStringOrColor.Color;
            //this.selectorItem1.Location = new System.Drawing.Point(133, 3);
            this.selectorItem1.Name = "selectorItem1";
            this.selectorItem1.PositionButtons = LibBinaryRelation.Controls.SelectorItem.PositionButtons1.right;
            this.tableLayoutPanel2.Controls.Add(this.selectorItem1, 1, 0);
            //this.selectorItem1.TabIndex = 11;

            set = new Set("X");
            this.DescriptionSet.Text = "Množina " + set.NameSet;
            l = new List<Brush>() 
                    {
                        Brushes.Blue,
                        Brushes.Green,
                        Brushes.Aqua,
                        Brushes.Gray,
                        Brushes.Yellow,
                        Brushes.Red,
                        Brushes.LemonChiffon,
                        Brushes.Black
                    };
            this.selectorItem1.Visible = false;
            this.AcceptButton = this.OK;
            this.CancelButton = this.Storno;
            height = -1;
            max_count_items = 20;
            actual_count_items = 0;
        }

        void Item_TextChanged(object sender, EventArgs e)
        {
            TextBox t = (TextBox)sender;
            if (t.Text.Contains(" ") == true)
            {
                t.Text = t.Text.Remove(t.Text.Length - 1);
                t.SelectionStart = t.Text.Length;
                Signal();
            }
        }

        Set set;
        List<Brush> l;
        int height;
        int max_count_items;
        int actual_count_items;
        TextBox Item;
        SelectorItem selectorItem1;

        public List<Brush> ColorsItem
        {
            set 
            { 
                l.Clear(); 
                value.ForEach(item => l.Add(item));
                this.selectorItem1.AddItem(l);
            }
        }

        public int SetLengthItem
        {
            set { this.Item.MaxLength = value; }
            get { return this.Item.MaxLength; }
        }

        public int SetMaxCountItems
        {
            set { max_count_items = value; }
        }

        public Set Set
        {
            get { return set; }
            set 
            {
                if (value.CountItemsInSet() <= max_count_items)
                {
                    if (value.ItemsUsingColor() == true)
                    {
                        this.Item.Visible = false;
                        this.selectorItem1.Visible = true;
                    }
                    else if(value.ItemsUsingName() == true)
                    {
                        this.Item.Visible = true;
                        this.selectorItem1.Visible = false;
                    }
                    set = value.Clone();
                    this.DescriptionSet.Text = "Množina " + set.NameSet;
                    actual_count_items = set.CountItemsInSet();
                    SetLabels();
                }
                else throw new Exception("Max pocet prvku v mnozine je " + max_count_items + ", tuto hodnotu lze měnit pomocí vlastnosti SetMaxCountItems");
            }
        }

        private void DrawRelationPaint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            float v_space = p.Width * 0.05f;
            Drawing1.DrawSet(p, e.Graphics, new RectangleF(v_space, p.Height * 0.1f, p.Width - 2 * v_space, p.Height), set, this.Font);
        }

        private void DrawRelationResize(object sender, EventArgs e)
        {
            this.DrawRelation.Invalidate();
        }

        private void AddItemClick(object sender, EventArgs e)
        {
            if (this.Item.Visible == true)
            {
                string name_item = this.Item.Text;
                if (name_item.Length == 0 || !set.AddItemToSet(name_item)) Signal();
                else this.Item.Text = "";
            }
            else 
            {
                if(set.AddItemToSet(l[this.selectorItem1.GetCurrentItem]) == false) this.selectorItem1.Signal();
            }
            SetLabels();
            this.DrawRelation.Invalidate();
        }

        private void RemoveItemClick(object sender, EventArgs e)
        {
            if (this.Item.Visible == true)
            {
                string name_item = this.Item.Text;
                if (name_item.Length == 0 || !set.RemoveItem(this.Item.Text)) Signal();
                else this.Item.Text = "";
            }
            else 
            {
                if(set.RemoveItem(l[this.selectorItem1.GetCurrentItem]) == false) this.selectorItem1.Signal();
            }
            SetLabels();
            this.DrawRelation.Invalidate();
        }

        private void RemoveAllClick(object sender, EventArgs e)
        {
            set.RemoveAllItems();
            SetLabels();
            this.DrawRelation.Invalidate();
        }

        private void OKClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void StornoClick(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CreateSetFontChanged(object sender, EventArgs e)
        {
            this.AutoSize = true;
            this.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            height = -1;
        }

        private void CreateSetShown(object sender, EventArgs e)
        {
            if (height == -1)
            {
                height = this.Height;
                this.MinimumSize = new Size(height, height);
                this.Size = new Size(height, height);
            }
            this.AutoSizeMode = AutoSizeMode.GrowOnly;
        }

        void SetLabels()
        {
            actual_count_items = set.CountItemsInSet();
            if (actual_count_items == 0) this.RemoveItem.Enabled = this.RemoveAll.Enabled = false;
            else this.RemoveItem.Enabled = this.RemoveAll.Enabled = true;

            if (actual_count_items == max_count_items) this.AddItem.Enabled = false;
            else this.AddItem.Enabled = true;

            this.label1.Text = "Maximální počet prvků v množině: " + max_count_items;
            this.label2.Text = "Aktuální počet prvků v množině: " + actual_count_items;
        }

        void Signal()
        {
            timer1.Interval = 100;
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Timer t = (Timer)sender;
            if (this.Item.BackColor == Color.Red)
            {
                this.Item.BackColor = this.BackColor;
                t.Stop();
            }
            else
            {
                this.Item.BackColor = Color.Red;
            }
        }
    }
}
