﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace LibBinaryRelation
{
    public enum Alignment { Near, Center, None};

        public class Drawing1
        {
            public static void SetAllControlsBackColor(Control control, Color color, params Type[] objects)
            {
                bool p = false;
                foreach (Type t in objects) { if (control.GetType() == t) { p = true; break; } }
                if (p == false)
                {
                    if (control.GetType() != typeof(MenuStrip) && control.GetType() != typeof(ToolStrip) && control.GetType() != typeof(Button) && control.GetType() != typeof(StatusStrip)) control.BackColor = color;
                    if (control.HasChildren)
                    {
                        foreach (Control childControl in control.Controls)
                        {
                            SetAllControlsBackColor(childControl, color, objects);
                        }
                    }
                }
            }

            public static Size MinimunSizeControl(Graphics g, Font font)
            {
                float width = 3 * g.MeasureString("R je binární relace na množině X", font).Width + g.MeasureString("Vlož dvojici do relace", font).Width;
                return new Size((int)width, (int)(width * 0.75f));
            }

            public static List<RectangleF> GetSizeAndPositionItemOfRelation(System.Windows.Forms.ScrollableControl control, Graphics g1, int x_start_position, int y_start_position, int x_end_position, int y_end_position, int number_places_in_item, Alignment h_alignment, Relation relation, Set set1, Set set2, Font font, List<int> items)
            {
                List<RectangleF> width_height_items = new List<RectangleF>();
                float height_item = font.GetHeight();//g1.MeasureString("<", font).Height;
                float h_space = height_item / 2;
                //string n_places_in_item = "M";
                //while (number_places_in_item != 1) { n_places_in_item += "M"; number_places_in_item--; }
                //float width_item1 = g1.MeasureString(n_places_in_item, font).Width;
                float width_item1 = set1.ItemsUsingColor() ? g1.MeasureString("M", font).Width : g1.MeasureString(GetTheMostLengthItemOfSetInRelation(g1, set1, set2, font),font).Width;
                float width_round_bracket = g1.MeasureString("{", font).Width;
                float width_stroke = g1.MeasureString(" , ", font).Width;
                float width_item = 2 * width_item1 + 2 * width_round_bracket + width_stroke;
                float width_name_relation = g1.MeasureString(relation.NameRelation + " = ", font).Width;
                PointF ascent_descent = GetAscentAndDescent(font);
                //int count_items_in_relation = relation.CountItemsInRelation();
                int count_items_on_row = (int)(((x_end_position - x_start_position) - (2 * width_round_bracket + width_name_relation)) / (width_item + width_stroke));
                //float piece = 0;
                //float kl = (float)count_items_in_relation / (float)count_items_on_row;
                //float count_rows_float = (float)count_items_in_relation / (float)count_items_on_row;
                //int count_rows = count_rows_float / (float)Math.Ceiling(count_rows_float) == 1 ? (int)count_rows_float : (int)++count_rows_float;
                //if (h_alignment == Alignment.Center) piece = ((x_end_position - x_start_position) - ((2 * width_round_bracket + width_name_relation) + (float)count_items_on_row * (width_item + width_stroke))) / 2;
                Point p = control.AutoScrollPosition;
                //StringFormat s = new StringFormat();
                //RectangleF width_height_item = new RectangleF(0, 0, width_item, height_item + h_space / 2);
                //width_height_item.X = x_start_position + piece;
                //width_height_item.Y = y_start_position + p.Y;
                float first_x_position = x_start_position + width_name_relation + width_round_bracket;
                float first_y_position = y_start_position + ascent_descent.Y / 2 + p.Y - h_space / 4;
                int row;
                int column;
                items.ForEach(item =>
                {

                    if (item < count_items_on_row) { row = 0; column = item; }
                    else
                    {
                        row = item / count_items_on_row;
                        column = item % count_items_on_row;
                    }
                    width_height_items.Add(new RectangleF(first_x_position + (width_item + width_stroke) * column,
                                                          first_y_position + (height_item + h_space) * row,
                                                          width_item,
                                                          height_item + h_space / 2));
                });
                return width_height_items;
            }

            public static void SignItemOfRelation(System.Windows.Forms.ScrollableControl control, Graphics g1, Rectangle rect, /*int x_start_position, int y_start_position, int x_end_position, int y_end_position,int number_places_in_item, Alignment h_alignment,*/ Relation relation, Set set1, Set set2, Font font,List<int> items,params Pen[] colors_items)
            {
                float height_item = font.GetHeight();
                float h_space = height_item / 2;
                float width_item1 = set1.ItemsUsingColor() ? g1.MeasureString("M", font).Width : g1.MeasureString(GetTheMostLengthItemOfSetInRelation(g1, set1, set2, font),font).Width;
                float width_round_bracket = g1.MeasureString("{", font).Width;
                float width_stroke = g1.MeasureString(" , ", font).Width;
                float width_item = 2 * width_item1 + 2 * width_round_bracket + width_stroke;
                float width_name_relation = g1.MeasureString(relation.NameRelation + " = ", font).Width;
                PointF ascent_descent = GetAscentAndDescent(font);
                float count_rows_float = (rect.Width - (2 * width_round_bracket + width_name_relation)) / (width_item + width_stroke);
                int count_items_on_row = count_rows_float < 1 ? 1 : (int)count_rows_float;
                Point p = control.AutoScrollPosition;
                System.Drawing.RectangleF width_height_item = new System.Drawing.RectangleF(0, 0, width_item, height_item + h_space/2);
                float first_x_position = rect.X + width_name_relation + width_round_bracket + p.X;
                float first_y_position = rect.Y + ascent_descent.Y / 2 + p.Y - h_space / 4; 
                int row;
                int column;
                int counter = -1;
                if (colors_items.Count() != 0)
                {
                    items.ForEach(item =>
                    {

                        if (item >= 0 && item <= relation.CountItemsInRelation())
                        {
                            if (item < count_items_on_row) { row = 0; column = item; }
                            else
                            {
                                row = item / count_items_on_row;
                                column = item % count_items_on_row;
                            }
                            width_height_item.X = first_x_position + (width_item + width_stroke) * column;
                            width_height_item.Y = first_y_position + (height_item + h_space) * row;
                            //g1.FillRectangle(Brushes.Beige, width_height_item);
                            if (counter < colors_items.Count() - 1) counter++;

                            g1.DrawLine(colors_items[counter], width_height_item.X, width_height_item.Y, width_height_item.X + width_height_item.Width, width_height_item.Y);
                            g1.DrawLine(colors_items[counter], width_height_item.X, width_height_item.Y, width_height_item.X, width_height_item.Y + width_height_item.Height);
                            g1.DrawLine(colors_items[counter], width_height_item.X, width_height_item.Y + width_height_item.Height, width_height_item.X + width_height_item.Width, width_height_item.Y + width_height_item.Height);
                            g1.DrawLine(colors_items[counter], width_height_item.X + width_height_item.Width, width_height_item.Y + width_height_item.Height, width_height_item.X + width_height_item.Width, width_height_item.Y); ;
                        }
                    });
                }
            }

            public static string GetTheMostLengthItemOfSetInRelation(Graphics g, Set set1, Set set2, Font font)
            {
                string item = "";
                for (int i = 0; i < set1.CountItemsInSet(); i++) if (g.MeasureString(set1.GetNameItem(i),font).Width > g.MeasureString(item,font).Width) item = set1.GetNameItem(i);

                if (!set1.Equals(set2)) for (int i = 0; i < set2.CountItemsInSet(); i++) if (g.MeasureString(set2.GetNameItem(i), font).Width > g.MeasureString(item, font).Width) item = set2.GetNameItem(i);

                return item;
            }

            public static void DrawRelation(System.Windows.Forms.ScrollableControl control, Graphics g1,Rectangle rect, Set set1, Set set2, Relation relation,Font font)
            {
                if ((set1.ItemsUsingColor() && set2.ItemsUsingName()) || (set1.ItemsUsingName() && set2.ItemsUsingColor())) throw new Exception("mnoziny set1 a set2 musi mit stejne typy prvku");
                g1.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                g1.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                float height_item = font.GetHeight();
                float h_space = height_item / 2;
                float width_round_bracket = g1.MeasureString("{", font).Width;
                float width_stroke = g1.MeasureString(" , ", font).Width;

                float width_item1 = set1.ItemsUsingColor()? g1.MeasureString("M", font).Width : g1.MeasureString(GetTheMostLengthItemOfSetInRelation(g1, set1, set2, font),font).Width;//g1.MeasureString(n_places_in_item, font).Width;
                float width_item = 2 * width_round_bracket + 2 * width_item1 + width_stroke; 
                float width_name_relation = g1.MeasureString(relation.NameRelation + " = ", font).Width;
                int count_items_in_relation = relation.CountItemsInRelation();
                float count_rows_float = (rect.Width - (2 * width_round_bracket + width_name_relation)) / (width_item + width_stroke);
                int count_items_on_row = count_rows_float < 1 ? 1 : (int)count_rows_float;
                count_rows_float = (float)count_items_in_relation / (float)count_items_on_row;
                int count_rows = count_rows_float / (float)Math.Ceiling(count_rows_float) == 1 ? (int)count_rows_float : (int)++count_rows_float;
                Point p = control.AutoScrollPosition;
                System.Drawing.RectangleF width_height_item = new System.Drawing.RectangleF(0, 0, width_item, height_item);
                width_height_item.X = rect.X + p.X;
                width_height_item.Y = rect.Y + p.Y;
                g1.DrawString(relation.NameRelation + " = ", font, Brushes.Black, width_height_item);
                width_height_item.X += width_name_relation;
                StringFormat s = new StringFormat();
                s.Alignment = StringAlignment.Center;
                width_height_item.Width = width_round_bracket;
                g1.DrawString("{", font, Brushes.Black, width_height_item, s);
                width_height_item.X += width_round_bracket;
                
                if (count_items_in_relation == 0)
                {
                    g1.DrawString("}", font, Brushes.Black, width_height_item,s);
                    control.AutoScrollMinSize = new Size(0, (int)Math.Ceiling(height_item));
                }
                else
                {
                    width_height_item.Width = width_item;
                    int count_depicted_items = 0;
                    int first = 0;
                    int last = count_rows;
                    float first_item_position = width_round_bracket + rect.X + width_name_relation;
                    control.AutoScrollMinSize = new Size(count_items_on_row == 1 ? (int)(first_item_position + width_item) + 20 : 0, (int)(Math.Ceiling(((float)count_rows) * (height_item + h_space) + (float)rect.Y)));

                    for (int i = first; i <= last; i++)
                    {
                        width_height_item.Y = (float)i * (height_item + h_space) + rect.Y + p.Y;

                        for (byte j = 0; j < count_items_on_row; j++)
                        {
                            if (count_depicted_items >= count_items_in_relation) goto END;
                            List<int> item_of_relation = relation.GetItemOfRelation(count_depicted_items);
                            width_height_item.X = (float)(j * (width_item + width_stroke)) + first_item_position + p.X;
                            if (set1.ItemsUsingColor()) DrawItemOfRelation(g1, width_height_item, set1.GetColorItem(item_of_relation[0]), set2.GetColorItem(item_of_relation[1]), width_round_bracket, width_stroke, width_item1, font);
                            else DrawItemOfRelation(g1, width_height_item, set1.GetNameItem(item_of_relation[0]), set2.GetNameItem(item_of_relation[1]), width_round_bracket, width_stroke, width_item1, font, relation.GetColorItemOfRelation(count_depicted_items));
                            count_depicted_items++;
                            if (count_depicted_items < count_items_in_relation)
                            {
                                width_height_item.X = width_height_item.X + width_height_item.Width;
                                width_height_item.Width = width_stroke;
                                g1.DrawString(",", font, Brushes.Black, width_height_item,s);
                                width_height_item.Width = width_item;
                            }
                            else
                            {
                                width_height_item.X = width_height_item.X + width_height_item.Width;
                                width_height_item.Width = width_round_bracket;
                                g1.DrawString("}", font, Brushes.Black, width_height_item,s);
                                width_height_item.Width = width_item;
                            }
                        }

                    }
                END: ;
                }
            }

            static void DrawItemOfRelation(Graphics g, System.Drawing.RectangleF width_height_item, string name_item1, string name_item2, float width_bracket, float width_stroke, float width_item1, Font font, Brush color_item)
            {
                //g.DrawRectangle(Pens.Black, new Rectangle((int)width_height_item.X,(int)width_height_item.Y,(int)width_height_item.Width,(int)width_height_item.Height));
                StringFormat s = new StringFormat();
                s.Alignment = StringAlignment.Center;
                Pen p = new Pen(color_item);
                DrawLeftBracket(g, width_height_item.X, width_height_item.Y, p, font);
                width_height_item.X = width_height_item.X + width_bracket;
                width_height_item.Width = width_item1;
                g.DrawString(name_item1, font, color_item, width_height_item,s);
                width_height_item.X = width_height_item.X + width_item1;
                width_height_item.Width = width_stroke;
                g.DrawString(",", font, color_item, width_height_item,s);
                width_height_item.X = width_height_item.X + width_stroke;
                width_height_item.Width = width_item1;
                g.DrawString(name_item2, font, color_item, width_height_item,s);
                width_height_item.X = width_height_item.X + width_item1;
                DrawRightBracket(g, width_height_item.X, width_height_item.Y, p, font);
            }

            //predpoklad ze width_hieght_item je presne na miru toho prvku
            public static void DrawItemOfRelation(Graphics g, System.Drawing.RectangleF width_height_item, Brush color_item1, Brush color_item2, float width_bracket, float width_stroke, float width_item1, Font font)
            {
                float average_of_item = GetAverageOfItem(font);
                StringFormat s = new StringFormat();
                s.Alignment = StringAlignment.Center;
                //s.LineAlignment = StringAlignment.Center;
                DrawLeftBracket(g, width_height_item.X, width_height_item.Y, Pens.Black, font);
                width_height_item.X = width_height_item.X + width_bracket;
                width_height_item.Width = width_item1;
                DrawItemOfSet(g, color_item1, average_of_item, width_height_item.X + width_height_item.Width/2 - average_of_item/2, width_height_item.Y + width_height_item.Height / 2 - average_of_item/2);
                width_height_item.X = width_height_item.X + width_item1;
                width_height_item.Width = width_stroke;
                g.DrawString(",", font, Brushes.Black, width_height_item, s);
                width_height_item.X = width_height_item.X + width_stroke;
                width_height_item.Width = width_item1;
                DrawItemOfSet(g, color_item2, average_of_item, width_height_item.X + width_height_item.Width / 2 - average_of_item / 2, width_height_item.Y + width_height_item.Height / 2 - average_of_item / 2);
                width_height_item.X = width_height_item.X + width_item1;
                DrawRightBracket(g, width_height_item.X, width_height_item.Y, Pens.Black, font);
            }

            public static List<float> GetSizeOfItemOfRelation(Graphics g, Font font, int number_places_in_item)
            {
                float height_item = font.GetHeight();
                float width_round_bracket = g.MeasureString("{", font).Width;
                float width_stroke = g.MeasureString(" , ", font).Width;
                string n_places_in_item = "M";
                while (number_places_in_item != 1) { n_places_in_item += "M"; number_places_in_item--; }
                float width_item1 = g.MeasureString(n_places_in_item, font).Width;
                float width_item = 2 * width_round_bracket + 2 * width_item1 + width_stroke;
                List<float> items_of_item = new List<float>();
                items_of_item.Add(width_item);
                items_of_item.Add(height_item);
                items_of_item.Add(width_round_bracket);
                items_of_item.Add(width_item1);
                items_of_item.Add(width_stroke);
                return items_of_item;
            }

            public static float GetAverageOfItem(Font font)
            {
                float f_line_spacing = font.GetHeight();
                float line_spacing = font.FontFamily.GetLineSpacing(font.Style);
                float descent = font.FontFamily.GetCellDescent(font.Style);
                float ascent = font.FontFamily.GetCellAscent(font.Style);
                float f_ascent = (f_line_spacing * ascent) / line_spacing;
                float f_descent = (f_line_spacing * descent) / line_spacing;
                return f_ascent - f_descent;
            }

            public static void DrawLeftBracket(Graphics g, float x, float y, Pen p, Font f)
            {
                SizeF s = g.MeasureString("{", f);
                /*float f_line_spacing = f.GetHeight();
                float line_spacing = f.FontFamily.GetLineSpacing(f.Style);
                float descent = f.FontFamily.GetCellDescent(f.Style);
                float ascent = f.FontFamily.GetCellAscent(f.Style);
                float f_ascent = (f_line_spacing * ascent) / line_spacing;
                float f_descent = (f_line_spacing * descent) / line_spacing;*/
                PointF asc_desc = GetAscentAndDescent(f);
                float top_y = y + asc_desc.Y;
                float bottom_y = y + asc_desc.Y + asc_desc.X;
                float left_x = x + s.Width * 0.25F;
                float right_x = x + s.Width * 0.75F;
                float middle_y = (bottom_y - top_y) / 2 + asc_desc.Y + y;
                g.DrawLine(p, right_x, top_y, left_x, middle_y);
                g.DrawLine(p, left_x, middle_y, right_x, bottom_y);
            }

            static PointF GetAscentAndDescent(Font f)
            {
                float f_line_spacing = f.GetHeight();
                float line_spacing = f.FontFamily.GetLineSpacing(f.Style);
                float descent = f.FontFamily.GetCellDescent(f.Style);
                float ascent = f.FontFamily.GetCellAscent(f.Style);
                float f_ascent = (f_line_spacing * ascent) / line_spacing;
                float f_descent = (f_line_spacing * descent) / line_spacing;
                return new PointF(f_ascent, f_descent);
            }

            public static void DrawRightBracket(Graphics g, float x,float y, Pen p, Font f)
            {
                SizeF s = g.MeasureString("}", f);
                /*float f_line_spacing = f.GetHeight();
                float line_spacing = f.FontFamily.GetLineSpacing(f.Style);
                float ascent = f.FontFamily.GetCellAscent(f.Style);
                float descent = f.FontFamily.GetCellDescent(f.Style);
                float f_descent = (f_line_spacing * descent) / line_spacing;
                float f_ascent = (f_line_spacing * ascent) / line_spacing;*/
                PointF asc_desc = GetAscentAndDescent(f);
                float top_y = y + asc_desc.Y;
                float bottom_y = y + asc_desc.Y + asc_desc.X;
                float left_x = x + s.Width * 0.25F;
                float right_x = x + s.Width * 0.75F;
                float middle_y = (bottom_y - top_y) / 2 + asc_desc.Y + y;
                g.DrawLine(p, left_x, top_y, right_x, middle_y);
                g.DrawLine(p, right_x, middle_y, left_x, bottom_y);
            }

            public static List<float> GetSizeAndParametersOfImageOfItem(Graphics g, string name_function, Font font)
            {
                List<float> param = new List<float>();
                SizeF size_name_function = g.MeasureString(name_function, font);
                float width_round_bracket = g.MeasureString("(", font).Width;
                float width_item = g.MeasureString(" \0 ", font).Width;
                float width_e = g.MeasureString("=", font).Width;
                param.Add(size_name_function.Width + 2 * width_round_bracket + 2 * width_item + width_e);
                param.Add(size_name_function.Height);
                param.Add(size_name_function.Width);
                param.Add(width_round_bracket);
                param.Add(width_item);
                param.Add(width_e);
                return param;
            }

            public static void DrawImageOfItem(Graphics g, float x, float y, List<float> parametres, string name_function, Brush vzor, Brush image, Font font)
            {
                float average_of_item = GetAverageOfItem(font);
                g.DrawString(name_function, font, Brushes.Black, x, y);
                x += parametres[2];
                g.DrawString("(", font, Brushes.Black, x, y);
                x += parametres[3];
                DrawItemOfSet(g, vzor, average_of_item, x + parametres[4] / 2 - average_of_item / 2, y + parametres[1] / 2 - average_of_item / 2);
                x += parametres[4];
                g.DrawString(")", font, Brushes.Black, x, y);
                x += parametres[3];
                g.DrawString("=", font, Brushes.Black, x, y);
                x += parametres[5];
                DrawItemOfSet(g, image, average_of_item, x + parametres[4] / 2 - average_of_item / 2, y + parametres[1] / 2 - average_of_item / 2);
            }

            public static void DrawSubscript(Graphics g, float x, float y, Font f, string letter, string sub_script)
            {
                SizeF size_letter = g.MeasureString(letter, f);
                float x_position_ss = x + size_letter.Width - 1;
                Font f_ss = new Font(f.FontFamily, size_letter.Height / 3, f.Style);
                float y_position_ss = y + (2 * size_letter.Height) / 3;
                g.DrawString(letter, f, Brushes.Black, x, y);
                g.DrawString(sub_script, f_ss, Brushes.Black, x_position_ss, y_position_ss);
            }

            public static void DrawSuperscript(Graphics g, float x, float y, Font f, string letter, string sup_script)
            {
                SizeF size_letter = g.MeasureString(letter, f);
                float x_position_ss = x + size_letter.Width - 1;
                float y_position_ss = y;//- size_letter.Height / 9;
                Font f_ss = new Font(f.FontFamily, size_letter.Height / 3,f.Style);
                g.DrawString(letter, f, Brushes.Black, x, y);
                g.DrawString(sup_script, f_ss, Brushes.Black, x_position_ss, y_position_ss);
            }

            public static SizeF GetSizeSuperScript(Graphics g, Font f, string letter, string sup_script)
            {
                SizeF size_letter = g.MeasureString(letter, f);
                Font f_ss = new Font(f.FontFamily, size_letter.Height / 3,f.Style);
                float width_sup_script = g.MeasureString(sup_script, f_ss).Width;
                SizeF size = new SizeF();
                size.Height = size_letter.Height;
                size.Width = size_letter.Width - 4 + width_sup_script;

                return size;
            }

            //f[-1] example of superscript
            public static void DrawText(Graphics g, float x, float y, Font f, string text, char character, List<Brush> colors_items)
            {
                string help_text;
                int counter_colors = 0;
                float average_item = GetAverageOfItem(f);
                SizeF Size_character = g.MeasureString(character.ToString(), f);
                while (text.Length != 0)
                {
                    int index1 = text.IndexOf('_');
                    int index2 = text.IndexOf('$');
                    int index3 = text.IndexOf(character);
                    if (index1 == -1) index1 = int.MaxValue;
                    if (index2 == -1) index2 = int.MaxValue;
                    if (index3 == -1) index3 = int.MaxValue;

                    if (index3 < index2 && index3 < index1)
                    {
                        help_text = text.Substring(0, index3);
                        g.DrawString(help_text, f, Brushes.Black, x, y);
                        x += g.MeasureString(help_text, f).Width;
                        DrawItemOfSet(g, colors_items[counter_colors], average_item, (x + Size_character.Width/2) - average_item/2, y + Size_character.Height / 2 - average_item / 2);
                        counter_colors++;
                        x += Size_character.Width;
                        text = text.Substring(index3 + 1);
                    }
                    else if(index2 < index1 && index2 < index3)
                    {
                        help_text = text.Substring(0, index2 - 1);
                        g.DrawString(help_text, f, Brushes.Black, x, y);
                        x += g.MeasureString(help_text, f).Width;
                        int start = index2 + 1;
                        int end = text.IndexOf("$",start);
                        string letter = text[index2 - 1].ToString();
                        string sup_script = text.Substring(start, end - start);
                        DrawSuperscript(g, x, y, f,letter, sup_script);
                        x += GetSizeSuperScript(g, f, letter, sup_script).Width;
                        text = text.Substring(end + 1);
                    }
                    else if (index1 < index2 && index1 < index3)
                    {
                        help_text = text.Substring(0, index1);
                        g.DrawString(help_text, f, Brushes.Black, x, y);
                        x += g.MeasureString(help_text, f).Width;
                        int start = index1 + 1;
                        int end = text.IndexOf("_", start);
                        string letter = text.Substring(start, end - start);
                        start = end + 1;
                        end = text.IndexOf("_", start);
                        string sup_script = text.Substring(start, end - start);
                        DrawSubscript(g, x, y, f, letter, sup_script);
                        x += GetSizeSuperScript(g, f, letter, sup_script).Width;
                        text = text.Substring(end + 1);
                    }
                    else
                    {
                        g.DrawString(text, f, Brushes.Black, x, y);
                        text = "";
                    }
                }
            }

            public static void DrawArrow(Graphics g, PointF p1, PointF p2, PointF p3,PointF p4, float length_arrow, int width_line, Brush color_line, bool with_arrow, bool with_line)
            {
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                Pen p = new Pen(color_line);
                p.Width = width_line;
                if (with_line) g.DrawBezier(p, p1, p2, p3, p4);

                if (with_arrow)
                {
                    System.Drawing.Drawing2D.GraphicsState g_s = g.Save();
                    PointF point = IntersectionBC(p3, p4, p4.X, p4.Y, length_arrow);
                    g.TranslateTransform(p4.X, p4.Y);
                    g.RotateTransform(-20);
                    g.TranslateTransform(-p4.X, -p4.Y);
                    g.DrawLine(p, p4, point);
                    g.Restore(g_s);
                    g_s = g.Save();
                    g.TranslateTransform(p4.X, p4.Y);
                    g.RotateTransform(20);
                    g.TranslateTransform(-p4.X, -p4.Y);
                    g.DrawLine(p, p4, point);
                    g.Restore(g_s);
                }
            }

            public static void DrawArrow(Graphics g, PointF p1, PointF p2,float length_arrow,int width_line, Brush color_line, bool with_arrow,bool with_line)
            {
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                Pen p = new Pen(color_line); 
                p.Width = width_line;
                if(with_line) g.DrawLine(p, p1, p2);

                if (with_arrow)
                {
                    System.Drawing.Drawing2D.GraphicsState g_s = g.Save();
                    PointF point = IntersectionBC(p1, p2, p2.X, p2.Y, length_arrow);
                    g.TranslateTransform(p2.X, p2.Y);
                    g.RotateTransform(-20);
                    g.TranslateTransform(-p2.X, -p2.Y);
                    g.DrawLine(p, p2, point);
                    g.Restore(g_s);
                    g_s = g.Save();
                    g.TranslateTransform(p2.X, p2.Y);
                    g.RotateTransform(20);
                    g.TranslateTransform(-p2.X, -p2.Y);
                    g.DrawLine(p, p2, point);
                    g.Restore(g_s);
                }
            }

            public static Font GetFont(Graphics g, int width, int height, string text, Font font)
            {
                Font f = new Font(font.FontFamily, height, font.Style,GraphicsUnit.Pixel);
                SizeF size_text;
                while (true)
                {
                    size_text = g.MeasureString(text, f);
                    if (size_text.Height < height && size_text.Width < width) break;
                    //try
                    //{
                        f = new Font(font.FontFamily, f.SizeInPoints - 1, font.Style);
                    //}
                    //catch { return font; }
                }

                return f;
            }

            /// <summary>
            /// Intersection between line and circle
            /// </summary>
            /// <returns></returns>
            public static PointF IntersectionBC(PointF p1, PointF p2, float m, float n, float radius)
            {
                double a = Math.Pow((-p1.X) + p2.X, 2) + Math.Pow((-p1.Y) + p2.Y, 2);
                double b = 2 * ((-p1.X) + p2.X) * (p1.X - m) + 2 * ((-p1.Y) + p2.Y) * (p1.Y - n);
                double c = Math.Pow(p1.X - m, 2) + Math.Pow(p1.Y - n, 2) - (radius * radius);

                float t = (float)(((-b) - Math.Sqrt((b * b) - 4 * a * c)) / (2 * a));

                return new PointF((1 - t) * p1.X + t * p2.X, (1 - t) * p1.Y + t * p2.Y);
            }

            /*public static SizeF MeasureCaptionSet(Graphics g, Font f, Set set)
            {
                string text = "Množina " + set.NameSet + " = { ";
                
                for (int i = 0; i < set.CountItemsInSet()-1; i++)
                {
                    text += @"  , ";
                }
                    text += @"  }";

                    return g.MeasureString(text, f);
            }*/

            public static void DrawSet(System.Windows.Forms.ScrollableControl control, Graphics g, RectangleF rect, Set set, Font f)
            {
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                int count_items = set.CountItemsInSet();
                string text = set.NameSet + " = {";
                Point p = control.AutoScrollPosition;
                rect.X += p.X;
                if (count_items == 0) DrawText(g,rect.X,rect.Y,f,text + " }",'p',new List<Brush>());//g.DrawString(text + " }", f, Brushes.Black, rect.X, rect.Y);
                else
                {
                    if (set.ItemsUsingColor() == true)
                    {
                        List<Brush> colors = set.ColorsItem;
                        DrawText(g, rect.X, rect.Y + p.Y, f, text, 'p', colors);
                        text = text.Replace("_", "");
                        float width_start = g.MeasureString(text, f).Width;
                        float width_stroke = g.MeasureString(",", f).Width;
                        float width_item = g.MeasureString("p", f).Width;
                        int count_items_on_row = (int)((rect.Width - width_start - 20) / (width_item + width_stroke));
                        int count_rows;
                        float count_rows1 = (float)colors.Count / count_items_on_row;
                        if (count_rows1 % 1 != 0) count_rows = (int)count_rows1 + 1;
                        else count_rows = (int)count_rows1;
                        control.AutoScrollMinSize = new Size(0, (int)(count_rows * f.Height + rect.Y + 5));
                        rect.X += width_start;
                        text = "";
                        int position = 0;
                        for (int i = 0; i < count_rows; i++)
                        {
                            if ((colors.Count - position) <= count_items_on_row)
                            {
                                count_items_on_row = colors.Count - position;
                                for (int j = 0; j < count_items_on_row - 1; j++) text += "p, ";
                                text += "p }";
                            }
                            else for (int j = 0; j < count_items_on_row; j++) text += "p, ";

                            DrawText(g, rect.X, i * f.Height + rect.Y + p.Y, f, text, 'p', colors.GetRange(position, count_items_on_row));
                            position += count_items_on_row;
                            text = "";
                        }
                    }
                    else
                    {
                        List<string> items = set.GetNamesItemsOnSet();
                        float width_stroke = g.MeasureString(", ", f).Width;
                        int count_rows = 0;
                        DrawText(g, rect.X, rect.Y + p.Y, f, text, 'p', new List<Brush>());
                        text = text.Replace("_","");
                        float width_start = g.MeasureString(text, f).Width;
                        rect.X += width_start;
                        int width = (int)(rect.Width - width_start - 20);
                        text = "";
                        string item = GetTheMostLengthItemOfSetInRelation(g, set, set, f);
                        for (int i = 0; i < count_items - 1; i++)
                        {
                            if (g.MeasureString(text + set.GetNameItem(i) + ", ", f).Width <= width) text += set.GetNameItem(i) + ", ";
                            else
                            {
                                if (text.Length == 0)
                                {
                                    g.DrawString(set.GetNameItem(i) + ", ", f, Brushes.Black, rect.X, count_rows * f.Height + rect.Y + p.Y);
                                    count_rows++;
                                }
                                else
                                {
                                    g.DrawString(text, f, Brushes.Black, rect.X, count_rows * f.Height + rect.Y + p.Y);
                                    i--;
                                    text = "";
                                    count_rows++;
                                }
                            }
                        }
                        if (g.MeasureString(text + set.GetNameItem(set.CountItemsInSet() - 1) + " }", f).Width <= width)
                        {
                            text += set.GetNameItem(set.CountItemsInSet() - 1) + "  }";
                            g.DrawString(text, f, Brushes.Black, rect.X, count_rows * f.Height + rect.Y + p.Y);
                        }
                        else
                        {
                            g.DrawString(text, f, Brushes.Black, rect.X, count_rows * f.Height + rect.Y + p.Y);
                            count_rows++;
                            g.DrawString(set.GetNameItem(set.CountItemsInSet() - 1) + "  }", f, Brushes.Black, rect.X, count_rows * f.Height + rect.Y + p.Y);
                        }

                        control.AutoScrollMinSize = new Size((int)(g.MeasureString(item + ",__}", f).Width + width_start), (int)((count_rows + 1) * f.Height + rect.Y + 5));
                    }
                }
            }

            /// <summary>
            /// function draws set which can have maximum 16 items
            /// </summary>
            /// <param name="g"></param>
            /// <param name="width"></param>
            /// <param name="height"></param>
            /// <param name="color_items"></param>

            public static void DrawSet(Graphics g, Set set, List<float> location_items, float average_items, PointF location_case_of_set, float average_case_of_set)
            {
                g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                //computation location and size items of set
                //List<float> location_and_size_items = LocationAndSizeItems(scale, set.CountItemsInSet(), width, height);
                //drawing case of set and items of set
                //SizeF size = g.MeasureString("Množina " + set.NameSet,font);
                //RectangleF rect = new RectangleF(location_case_of_set.X,location_case_of_set.Y - size.Height,size.Width,size.Height);
                //g.DrawString("Množina " + set.NameSet, font, Brushes.Black, rect);
                DrawCaseOfSet(g, average_case_of_set, location_case_of_set.X, location_case_of_set.Y);
                byte counter = 0;
                for (int i = 0; i < set.CountItemsInSet(); i++)
                {
                    DrawItemOfSet(g, set.GetColorItem(i), average_items, location_items[counter], location_items[counter + 1]);
                    counter += 2;
                }
            }

            public static void DrawItemOfSet(Graphics g, Brush color, float average, float x, float y)
            {
                g.FillEllipse(color, x, y, average, average);
            }

            public static void DrawItemOfSet(Graphics g, string name_item, float average, float x, float y, Font font)
            {
                Pen p = new Pen(Color.Black);
                p.Width = 1;
                g.DrawEllipse(p, x, y, average, average);
                StringFormat s = new StringFormat();
                s.Alignment = StringAlignment.Center;
                s.LineAlignment = StringAlignment.Center;
                float a = average / (float)Math.Sqrt(2);
                float move = average - (average / 2 + a / 2);
                RectangleF rect = new RectangleF(x + move, y + move, a, a);
                //Font f = GetFont(g, (int)rect.Width, (int)rect.Height, name_item, font);
                g.DrawString(name_item, font, Brushes.Black, rect, s);
            }

            public static void DrawCaseOfSet(Graphics g, float average, float x, float y)
            {
                Pen p = new Pen(Color.Black);
                p.Width = 1;
                g.DrawEllipse(p, x, y, average, average);
            }

            //function computes and return location and size every item of set 
            //and return location and size case of set

            public static List<float> LocationAndSizeItems(float scale, int count_items, float x, float y, float width, float height)
            {
                List<float> coordinate_items = new List<float>();
                float length_side_biggersquare;
                float move_along_xcoord;
                float move_along_ycoord;
                if (width >= height)
                {
                    length_side_biggersquare = height * scale;
                    move_along_xcoord = width / 2 - length_side_biggersquare / 2 + x;
                    move_along_ycoord = (height - length_side_biggersquare) / 2 + y;
                }
                else
                {
                    length_side_biggersquare = width * scale;
                    move_along_xcoord = (width - length_side_biggersquare) / 2 + x;
                    move_along_ycoord = height / 2 - length_side_biggersquare / 2 + y;
                }
                coordinate_items.Add(length_side_biggersquare);
                coordinate_items.Add(move_along_xcoord);
                coordinate_items.Add(move_along_ycoord);
                if (count_items != 0)
                {
                    float biggest_coordinate = (float)(length_side_biggersquare / Math.Sqrt(2.0)) / 8;
                    float additional_coordinate = (length_side_biggersquare - (biggest_coordinate * 8)) / 2;
                    ///////
                    coordinate_items.Add((biggest_coordinate * 2) - 8);
                    additional_coordinate += 4;
                    if (count_items == 1)
                    {
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_ycoord);
                    }
                    else if (count_items == 2)
                    {
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add(biggest_coordinate + additional_coordinate + move_along_ycoord);
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add((biggest_coordinate * 5) + additional_coordinate + move_along_ycoord);
                    }
                    else if (count_items == 3)
                    {
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add(biggest_coordinate + additional_coordinate + move_along_ycoord);
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_ycoord);
                        coordinate_items.Add((biggest_coordinate * 3) + additional_coordinate + move_along_xcoord);
                        coordinate_items.Add((biggest_coordinate * 5) + additional_coordinate + move_along_ycoord);
                    }/*
                    else if (count_items == 4)
                    {
                        for (byte i = 1; i <= 5; i *= 5)
                        {
                            for (byte j = 1; j <= 5; j *= 5)
                            {
                                coordinate_items.Add((biggest_coordinate * j) + additional_coordinate + move_along_xcoord);
                                coordinate_items.Add((biggest_coordinate * i) + additional_coordinate + move_along_ycoord);
                            }
                        }
                    }
                    else if (count_items <= 6)
                    {
                        for (byte i = 1; i <= 5; i *= 5)
                        {
                            for (byte j = 1; j <= 5; j += 2)
                            {
                                coordinate_items.Add((biggest_coordinate * j) + additional_coordinate + move_along_xcoord);
                                coordinate_items.Add((biggest_coordinate * i) + additional_coordinate + move_along_ycoord);
                            }
                        }
                    }
                    else if (count_items <= 8)
                    {
                        for (byte i = 1; i <= 5; i *= 5)
                        {
                            for (byte j = 0; j <= 3; j++)
                            {
                                coordinate_items.Add(((biggest_coordinate * 2) * j) + additional_coordinate + move_along_xcoord);
                                coordinate_items.Add((biggest_coordinate * i) + additional_coordinate + move_along_ycoord);
                            }
                        }
                    }
                    else if (count_items <= 12)
                    {
                        for (byte i = 1; i <= 5; i += 2)
                        {
                            for (byte j = 0; j <= 3; j++)
                            {
                                coordinate_items.Add(((biggest_coordinate * 2) * j) + additional_coordinate + move_along_xcoord);
                                coordinate_items.Add((biggest_coordinate * i) + additional_coordinate + move_along_ycoord);
                            }
                        }
                    }
                    else
                    {
                        for (byte i = 0; i <= 3; i++)
                        {
                            for (byte j = 0; j <= 3; j++)
                            {
                                coordinate_items.Add(((biggest_coordinate * 2) * j) + additional_coordinate + move_along_xcoord);
                                coordinate_items.Add(((biggest_coordinate * 2) * i) + additional_coordinate + move_along_ycoord);
                            }
                        }
                    }*/
                }
                return coordinate_items;
            }
        }
    }
