﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace LibBinaryRelation
{
    public class Relation
    {
        public Relation(string name_relation)
        {
            relation = new List<List<int>>();
            this.name_relation = name_relation;
            this.color_items = new List<Brush>();
        }

        string name_relation;
        List<List<int>> relation;
        List<Brush> color_items;

        public string NameRelation
        {
            get { return name_relation; }
            set { name_relation = value; }
        }

        public List<int> GetItemsInRelationWith(int number_item, int position_item)
        {
            if (position_item == 0 || position_item == 1)
            {
                List<int> items = new List<int>();
                int position_item1 = position_item == 0 ? 1 : 0;
                relation.ForEach(item1 => { if (item1[position_item] == number_item)items.Add(item1[position_item1]); });
                return items;
            }
            else return null;
        }

        public int GetItemOfItemOfRelation(int number_of_item_of_relation, int number_of_item)
        {
            return relation[number_of_item_of_relation][number_of_item];
        }

        public List<int> GetItemOfRelation(int number_item)
        {
            return relation[number_item];
        }

        public Brush GetColorItemOfRelation(int number_item)
        {
            return color_items[number_item];
        }

        public int CountItemsInRelation()
        {
            return relation.Count;
        }


        public void RemoveAllItems()
        {
            relation.Clear();
            color_items.Clear();
        }

        public bool AddItemToRelation(int number_item1, int number_item2,Brush color_item)
        {
            if (GetNumberOfItemOfRelation(number_item1, number_item2) == -1)
            {
                List<int> new_item = new List<int>();
                new_item.Add(number_item1); new_item.Add(number_item2);
                relation.Add(new_item);
                color_items.Add(color_item);
                return true;
            }
            else return false;
        }

        public bool RemoveItemFromRelation(int number_item1, int number_item2)
        {
            int number_of_item = GetNumberOfItemOfRelation(number_item1, number_item2);
            if (number_of_item != -1)
            {
                relation.RemoveAt(number_of_item);
                color_items.RemoveAt(number_of_item);
                return true;
            }
            else return false;
        }

        public int GetNumberOfItemOfRelation(int item1, int item2)
        {

           return relation.FindIndex(item_of_relation => item_of_relation[0] == item1 && item_of_relation[1] == item2);
        }

        public Relation Clone()
        {
            Relation clone_relation = new Relation(name_relation);
            for (int i = 0; i < relation.Count; i++) clone_relation.AddItemToRelation(relation[i][0], relation[i][1], color_items[i]);
            return clone_relation;
        }
    }
}
