﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace LibBinaryRelation
{
    public class Set
    {
        public Set(string name_set)
        {
            colors_items = new List<Brush>();
            names_items = new List<string>();
            this.name_set = name_set;
        }

        string name_set;
        List<Brush> colors_items;
        List<string> names_items;

        public List<Brush> ColorsItem
        {
            get 
            { 
                return colors_items;
            }
        }

        public string NameSet
        {
            get { return name_set; }
            set { name_set = value; }
        }

        public bool ItemsUsingColor()
        {
            if (colors_items.Count == 0) return false;
            else return true;
        }

        public bool ItemsUsingName()
        {
            if (names_items.Count == 0) return false;
            else return true;
        }

        public Brush GetColorItem(int number_item)
        {
            if (number_item > colors_items.Count - 1) return null;
            return colors_items[number_item];
        }

        public string GetNameItem(int number_item)
        {
            if (number_item > names_items.Count - 1) return null;
            return names_items[number_item];
        }

        public List<string> GetNamesItemsOnSet()
        {
            return names_items;
        }

        public int CountItemsInSet()
        {
            if (names_items.Count != 0) return names_items.Count;
            else return colors_items.Count;
        }

        public bool AddItemToSet(Brush color, string name_item)
        {
            if (colors_items.Contains(color) || names_items.Contains(name_item)) return false;
            colors_items.Add(color); 
            names_items.Add(name_item);
            return true;     
        }

        public bool AddItemToSet(string name_item)
        {
            if (names_items.Contains(name_item)) return false;
            names_items.Add(name_item);
            return true;
        }

        public bool AddItemToSet(Brush color)
        {
            if (colors_items.Contains(color)) return false;
            colors_items.Add(color);
            return true;
        }

        public bool RemoveItem(string name_item)
        {
           return names_items.Remove(name_item);
        }

        public bool RemoveItem(Brush item)
        {
            return colors_items.Remove(item);
        }

        public void RemoveAllItems()
        {
            colors_items.Clear(); names_items.Clear();
        }

        public Set Clone()
        {
            Set clone_set = new Set(name_set);
            if (colors_items.Count != 0) colors_items.ForEach(item => clone_set.AddItemToSet(item));
            else names_items.ForEach(item => clone_set.AddItemToSet(item));
            return clone_set;
        }
    }
}
